searchNodes=[{"type":"module","title":"Patch.Case","doc":"","ref":"Patch.Case.html"},{"type":"module","title":"Patch.Importer","doc":"","ref":"Patch.Importer.html"},{"type":"function","title":"Patch.Importer.all/0","doc":"","ref":"Patch.Importer.html#all/0"},{"type":"module","title":"Patch","doc":"Patch - Ergonomic Mocking for Elixir Patch makes it easy to mock one or more functions in a module returning a value or executing custom logic. Patches and Spies allow tests to assert or refute that function calls have been made. Using Patch is as easy as adding a single line to your test case. use Patch After this all the patch functions will be available, see the function documentation for details.","ref":"Patch.html"},{"type":"macro","title":"Patch.assert_any_call/1","doc":"Asserts that the given module and function has been called with any arity. patch ( Example , :function , :patch ) assert_any_call Example . function # fails Example . function ( 1 , 2 , 3 ) assert_any_call Example . function # passes","ref":"Patch.html#assert_any_call/1"},{"type":"function","title":"Patch.assert_any_call/2","doc":"Asserts that the given module and function has been called with any arity. patch ( Example , :function , :patch ) assert_any_call Example , :function # fails Example . function ( 1 , 2 , 3 ) assert_any_call Example , :function # passes This function exists for advanced use cases where the module or function are not literals in the test code. If they are literals then assert_any_call/1 should be preferred.","ref":"Patch.html#assert_any_call/2"},{"type":"macro","title":"Patch.assert_called/1","doc":"Given a call will assert that a matching call was observed by the patched function. This macro fully supports patterns and will perform non-hygienic binding similar to ExUnit's assert_receive/3 and assert_received/2 . patch ( Example , :function , :patch ) Example . function ( 1 , 2 , 3 ) assert_called Example . function ( 1 , 2 , 3 ) # passes assert_called Example . function ( 1 , _ , 3 ) # passes assert_called Example . function ( 4 , 5 , 6 ) # fails assert_called Example . function ( 4 , _ , 6 ) # fails","ref":"Patch.html#assert_called/1"},{"type":"macro","title":"Patch.assert_called/2","doc":"Given a call will assert that a matching call was observed exactly the number of times provided by the patched function. This macro fully supports patterns and will perform non-hygienic binding similar to ExUnit's assert_receive/3 and assert_received/2 . Any binds will bind to the latest matching call values. patch ( Example , :function , :patch ) Example . function ( 1 , 2 , 3 ) assert_called Example . function ( 1 , 2 , 3 ) , 1 # passes assert_called Example . function ( 1 , _ , 3 ) , 1 # passes Example . function ( 1 , 2 , 3 ) assert_called Example . function ( 1 , 2 , 3 ) , 2 # passes assert_called Example . function ( 1 , _ , 3 ) , 2 # passes","ref":"Patch.html#assert_called/2"},{"type":"macro","title":"Patch.assert_called_once/1","doc":"Given a call will assert that a matching call was observed exactly once by the patched function. This macro fully supports patterns and will perform non-hygienic binding similar to ExUnit's assert_receive/3 and assert_received/2 . patch ( Example , :function , :patch ) Example . function ( 1 , 2 , 3 ) assert_called_once Example . function ( 1 , 2 , 3 ) # passes assert_called_once Example . function ( 1 , _ , 3 ) # passes Example . function ( 1 , 2 , 3 ) assert_called_once Example . function ( 1 , 2 , 3 ) # fails assert_called_once Example . function ( 1 , _ , 3 ) # fails","ref":"Patch.html#assert_called_once/1"},{"type":"function","title":"Patch.debug/1","doc":"Enable or disable library level debugging. There is a suite level configuration that can be set by using config :patch , debug : true # or false Calling this helper will enable or disable debugging for a given test. Library level debugging can be useful when patch behavior isn't meeting expectations. Additional logging will occur at the debug log level using Logger to provide insight into how Patch is working.","ref":"Patch.html#debug/1"},{"type":"function","title":"Patch.expose/2","doc":"Expose can be used to turn private functions into public functions for the purpose of testing them. To expose every private function as a public function, pass the sentinel value :all . expose ( Example , :all ) Otherwise pass a Keyword.t(arity) of the functions to expose. For example, if one wanted to expose private_function/1 and private_function/2 . expose ( Example , [ private_function : 1 , private_function : 2 ] ) After exposing a function, attempting to call the exposed function will cause the Elixir Compiler to flag calls to exposed functions as a warning. There are companion macros private/1 and private/2 that test authors can wrap their calls with to prevent warnings.","ref":"Patch.html#expose/2"},{"type":"function","title":"Patch.fake/2","doc":"Fakes out a module with an alternative implementation. The real module can still be accessed with real/1 . For example, if your project has the module Example.Datastore and there's a fake available in the testing environment named Example.Test.InMemoryDatastore the following table describes which calls are executed by which code before and after faking with the following call. fake ( Example.Datastore , Example.Test.InMemoryDatastore ) Calling Code Responding Module before fake/2 Responding Module after fake/2 Example.Datastore.get/1 Example.Datastore.get/1 Example.Test.InMemoryDatastore.get/1 Example.Test.InMemoryDatastore.get/1 Example.Test.InMemoryDatastore.get/1 Example.Test.InMemoryDatastore.get/1 real(Example.Datastore).get/1 (UndefinedFunctionError) Example.Datastore.get/1 The fake module can use the renamed module to access the original implementation.","ref":"Patch.html#fake/2"},{"type":"function","title":"Patch.history/2","doc":"Get all the observed calls to a module. These calls are expressed as a {name, argument} tuple and can either be provided in ascending (oldest first) or descending (newest first) order by providing a sorting of :asc or :desc , respectively. Example . example ( 1 , 2 , 3 ) Example . function ( :a ) assert history ( Example ) == [ { :example , [ 1 , 2 , 3 ] } , { :function , [ :a ] } ] assert history ( Example , :desc ) == [ { :function , [ :a ] } , { :example , [ 1 , 2 , 3 ] } ] For asserting or refuting that a call happened the assert_called/1 , assert_any_call/2 , refute_called/1 , and refute_any_call/2 functions provide a more convenient API.","ref":"Patch.html#history/2"},{"type":"function","title":"Patch.inject/4","doc":"","ref":"Patch.html#inject/4"},{"type":"function","title":"Patch.listen/3","doc":"Starts a listener process. Each listener should provide a unique tag that will be used when forwarding messages to the test process. Named Processes When used on a named process, this is sufficient to begin intercepting all messages to the named process. listen ( :listener , Example ) Unnamed Processes When used on an unnamed process, the process that is spawned will forward any messages to the caller and target process but any processes holding a reference to the old pid will need to be updated. replace/3 can be used to replace part of a running process with the listener { :ok , listener } = listen ( :listener , original ) replace ( target , [ :original ] , listener ) inject/3 provides a nice convenience when you want to wrap a listener around the pid in the state. inject ( :listener , target , [ :original ] ) This code will look for the key :original in the target process's state, and wrap it with a listener tagged with :listener Substituting for a Process Listeners can also act as a complete substitute for a process. This is useful in scenarios where one Process starts other Processes but starting those Processes is outside of the bounds of the test. In those cases you can start a &quot;targetless listener.&quot; replace/3 can be used to replace part of a running process with the substitute listener. { :ok , listener } = listen ( :listener ) replace ( target , [ :original ] , listener ) inject/3 provides a nice conveninece when the state already has a nil that you want to replace with a listener inject ( :listener , target , [ :original ] ) This code will look for the key :original in the target process's state, finding it nil it will create a &quot;targetless listener&quot; tagged with :listener and put it in the state.","ref":"Patch.html#listen/3"},{"type":"function","title":"Patch.patch/3","doc":"Patches a function in a module When called with a function the function will be called instead of the original function and its results returned. patch ( Example , :function , fn arg -&gt; { :mock , arg } end ) assert Example . function ( :test ) == { :mock , :test } To handle multiple arities create a callable/2 with the :list option and the arguments will be wrapped to the function in a list. patch ( Example , :function , callable ( fn [ ] -&gt; :zero [ a ] -&gt; { :one , a } [ a , b ] -&gt; { :two , a , b } end , :list ) ) assert Example . function ( ) == :zero assert Example . function ( 1 ) == { :one , 1 } assert Example . function ( 1 , 2 ) == { :two , 1 , 2 } To provide a function as a literal value to be returned, use the scalar/1 function. patch ( Example , :function , scalar ( fn arg -&gt; { :mock , arg } end ) ) callable = Example . function ( ) assert callable . ( :test ) == { :mock , :test } The function cycle/1 can be given a list which will be infinitely cycled when the function is called. patch ( Example , :function , cycle ( [ 1 , 2 , 3 ] ) ) assert Example . function ( ) == 1 assert Example . function ( ) == 2 assert Example . function ( ) == 3 assert Example . function ( ) == 1 assert Example . function ( ) == 2 assert Example . function ( ) == 3 assert Example . function ( ) == 1 The function raises/1 can be used to raise/1 a RuntimeError when the function is called. patch ( Example , :function , raises ( &quot;patched&quot; ) ) assert_raise RuntimeError , &quot;patched&quot; , fn -&gt; Example . function ( ) end The function raises/2 can be used to raise/2 any exception with any attributes when the function is called. patch ( Example , :function , raises ( ArgumentError , message : &quot;patched&quot; ) ) assert_raise ArgumentError , &quot;patched&quot; , fn -&gt; Example . function ( ) end The function sequence/1 can be given a list which will be used until a single value is remaining, the remaining value will be returned on all subsequent calls. patch ( Example , :function , sequence ( [ 1 , 2 , 3 ] ) ) assert Example . function ( ) == 1 assert Example . function ( ) == 2 assert Example . function ( ) == 3 assert Example . function ( ) == 3 assert Example . function ( ) == 3 assert Example . function ( ) == 3 assert Example . function ( ) == 3 The function throws/1 can be given a value to throw/1 when the function is called. patch ( Example , :function , throws ( :patched ) ) assert catch_throw ( Example . function ( ) ) == :patched Any other value will be returned as a literal scalar value when the function is called. patch ( Example , :function , :patched ) assert Example . function ( ) == :patched","ref":"Patch.html#patch/3"},{"type":"macro","title":"Patch.private/1","doc":"Suppress warnings for using exposed private functions in tests. Patch allows you to make a private function public via the expose/2 function. Exposure happens dynamically at test time. The Elixir Compiler will flag calls to exposed functions as a warning. One way around this is to change the normal function call into an apply/3 but this is cumbersome and makes tests harder to read. This macro just rewrites a normal looking call into an apply/3 so the compiler won't complain about calling an exposed function. expose ( Example , :all ) patch ( Example , :private_function , :patched ) assert Example . private_function ( ) == :patched # Compiler will warn about call to undefined function assert apply ( Example , :private_function , [ ] ) == :patched # Compiler will not warn assert private ( Example . private_function ( ) ) == :patched # Same as previous line, but looks nicer.","ref":"Patch.html#private/1"},{"type":"macro","title":"Patch.private/2","doc":"Suppress warnings for using exposed private functions in tests. Patch allows you to make a private function public via the expose/2 function. Exposure happens dynamically at test time. The Elixir Compiler will flag calls to exposed functions as a warning. One way around this is to change the normal function call into an apply/3 but this is cumbersome and makes tests harder to read. This macro just rewrites a normal looking call into an apply/3 so the compiler won't complain about calling an exposed function, with support for pipelines. expose ( Example , :all ) example_that_warns = Example . new ( ) |&gt; Example . private_function ( ) # Compiler will warn about call to undefined function example_that_does_not_warn Example . new ( ) |&gt; private ( Example . private_function ( ) ) # Compiler will not warn and Example.new() is provided # as the first argument to Example.private_function/1","ref":"Patch.html#private/2"},{"type":"function","title":"Patch.real/1","doc":"Gets the real module name for a fake. This is useful for Fakes that want to defer some part of the functionality back to the real module. def Example do def calculate ( a ) do # ...snip some complex calculations... result end end def Example.Fake do import Patch , only : [ real : 1 ] def calculate ( a ) do real_result = real ( Example ) . calculate ( a ) { :fake , real_result } end end","ref":"Patch.html#real/1"},{"type":"macro","title":"Patch.refute_any_call/1","doc":"Refutes that the given module and function has been called with any arity. patch ( Example , :function , :patch ) refute_any_call Example . function # passes Example . function ( 1 , 2 , 3 ) refute_any_call Example . function # fails","ref":"Patch.html#refute_any_call/1"},{"type":"function","title":"Patch.refute_any_call/2","doc":"Refutes that the given module and function has been called with any arity. patch ( Example , :function , :patch ) refute_any_call Example , :function # passes Example . function ( 1 , 2 , 3 ) refute_any_call Example , :function # fails This function exists for advanced use cases where the module or function are not literals in the test code. If they are literals then refute_any_call/1 should be preferred.","ref":"Patch.html#refute_any_call/2"},{"type":"macro","title":"Patch.refute_called/1","doc":"Given a call will refute that a matching call was observed by the patched function. This macro fully supports patterns. patch ( Example , :function , :patch ) Example . function ( 1 , 2 , 3 ) refute_called Example . function ( 4 , 5 , 6 ) # passes refute_called Example . function ( 4 , _ , 6 ) # passes refute_called Example . function ( 1 , 2 , 3 ) # fails refute_called Example . function ( 1 , _ , 3 ) # fails","ref":"Patch.html#refute_called/1"},{"type":"macro","title":"Patch.refute_called/2","doc":"Given a call will refute that a matching call was observed exactly the number of times provided by the patched function. This macro fully supports patterns. patch ( Example , :function , :patch ) Example . function ( 1 , 2 , 3 ) refute_called Example . function ( 1 , 2 , 3 ) , 2 # passes refute_called Example . function ( 1 , _ , 3 ) , 2 # passes Example . function ( 1 , 2 , 3 ) refute_called Example . function ( 1 , 2 , 3 ) , 1 # passes refute_called Example . function ( 1 , _ , 3 ) , 1 # passes","ref":"Patch.html#refute_called/2"},{"type":"macro","title":"Patch.refute_called_once/1","doc":"Given a call will refute that a matching call was observed exactly once by the patched function. This macro fully supports patterns. patch ( Example , :function , :patch ) Example . function ( 1 , 2 , 3 ) refute_called_once Example . function ( 1 , 2 , 3 ) # fails refute_called_once Example . function ( 1 , _ , 3 ) # fails Example . function ( 1 , 2 , 3 ) refute_called_once Example . function ( 1 , 2 , 3 ) # passes refute_called_once Example . function ( 1 , _ , 3 ) # passes","ref":"Patch.html#refute_called_once/1"},{"type":"function","title":"Patch.replace/3","doc":"Convenience function for replacing part of the state of a running process. Uses the Access module to traverse the state structure according to the given keys . Structs have special handling so that they can be updated without having to implement the Access behavior. For example to replace the key :key in the map found under the key :map with the value :replaced replace ( target , [ :map , :key ] , :replaced )","ref":"Patch.html#replace/3"},{"type":"function","title":"Patch.restore/1","doc":"Remove any mocks or spies from the given module original = Example . example ( ) patch ( Example , :example , :patched ) assert Example . example ( ) == :patched restore ( Example ) assert Example . example ( ) == original","ref":"Patch.html#restore/1"},{"type":"function","title":"Patch.restore/2","doc":"Remove any patches associated with a function in a module. original = Example . example ( ) patch ( Example , :example , :example_patch ) patch ( Example , :other , :other_patch ) assert Example . example ( ) == :example_patch assert Example . other ( ) == :other_patch restore ( Example , :example ) assert Example . example ( ) == original assert Example . other ( ) == :other_patch","ref":"Patch.html#restore/2"},{"type":"function","title":"Patch.spy/1","doc":"Spies on the provided module Once a module has been spied on the calls to that module can be asserted / refuted without changing the behavior of the module. spy ( Example ) Example . example ( 1 , 2 , 3 ) assert_called Example . example ( 1 , 2 , 3 ) # passes","ref":"Patch.html#spy/1"},{"type":"module","title":"Patch.Listener","doc":"","ref":"Patch.Listener.html"},{"type":"function","title":"Patch.Listener.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Patch.Listener.html#child_spec/1"},{"type":"function","title":"Patch.Listener.init/1","doc":"Callback implementation for GenServer.init/1 .","ref":"Patch.Listener.html#init/1"},{"type":"function","title":"Patch.Listener.start_link/4","doc":"","ref":"Patch.Listener.html#start_link/4"},{"type":"function","title":"Patch.Listener.target/1","doc":"","ref":"Patch.Listener.html#target/1"},{"type":"type","title":"Patch.Listener.capture_replies_option/0","doc":"Option to control whether or not to capture GenServer.call replies. Defaults to true","ref":"Patch.Listener.html#t:capture_replies_option/0"},{"type":"type","title":"Patch.Listener.option/0","doc":"Sum-type of all valid options","ref":"Patch.Listener.html#t:option/0"},{"type":"type","title":"Patch.Listener.t/0","doc":"","ref":"Patch.Listener.html#t:t/0"},{"type":"type","title":"Patch.Listener.tag/0","doc":"Listeners are started with a tag so the listening process can differentiate between multiple listeners.","ref":"Patch.Listener.html#t:tag/0"},{"type":"type","title":"Patch.Listener.target/0","doc":"Listeners listen to a target.","ref":"Patch.Listener.html#t:target/0"},{"type":"type","title":"Patch.Listener.timeout_option/0","doc":"Option to control how long the listener should wait for GenServer.call Value is either the number of milliseconds to wait or the :infinity atom. If capture_replies is set to false this setting has no effect. Defaults to 5000","ref":"Patch.Listener.html#t:timeout_option/0"},{"type":"module","title":"Patch.Listener.Supervisor","doc":"","ref":"Patch.Listener.Supervisor.html"},{"type":"function","title":"Patch.Listener.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Patch.Listener.Supervisor.html#child_spec/1"},{"type":"function","title":"Patch.Listener.Supervisor.init/1","doc":"Callback implementation for DynamicSupervisor.init/1 .","ref":"Patch.Listener.Supervisor.html#init/1"},{"type":"function","title":"Patch.Listener.Supervisor.start_child/4","doc":"","ref":"Patch.Listener.Supervisor.html#start_child/4"},{"type":"function","title":"Patch.Listener.Supervisor.start_link/1","doc":"","ref":"Patch.Listener.Supervisor.html#start_link/1"},{"type":"module","title":"Patch.Mock","doc":"","ref":"Patch.Mock.html"},{"type":"function","title":"Patch.Mock.expose/2","doc":"Expose private functions in a module. If the module is not already mocked, calling this function will mock it.","ref":"Patch.Mock.html#expose/2"},{"type":"function","title":"Patch.Mock.history/1","doc":"Gets the call history for a module. If the module is not already mocked, this function returns an empty new history.","ref":"Patch.Mock.html#history/1"},{"type":"function","title":"Patch.Mock.module/2","doc":"Mocks the given module. Mocking a module accepts two options, see the option/0 type in this module for details.","ref":"Patch.Mock.html#module/2"},{"type":"function","title":"Patch.Mock.register/3","doc":"Registers a mock value for a function. If the module is not already mocked, this function will mock it with no private functions exposed.","ref":"Patch.Mock.html#register/3"},{"type":"function","title":"Patch.Mock.restore/1","doc":"Restores a module to pre-patch functionality. If the module is not already mocked, this function no-ops.","ref":"Patch.Mock.html#restore/1"},{"type":"function","title":"Patch.Mock.restore/2","doc":"Restores a function in a module to pre-patch functionality. If the module or function are not already mocked, this function no-ops.","ref":"Patch.Mock.html#restore/2"},{"type":"type","title":"Patch.Mock.exposes/0","doc":"What exposures should be made in a module. :public will only expose the public functions :all will expose both public and private functions A list of exports can be provided, they will be added to the :public functions.","ref":"Patch.Mock.html#t:exposes/0"},{"type":"type","title":"Patch.Mock.exposes_option/0","doc":"The exposes option controls if any private functions should be exposed. The default is :public .","ref":"Patch.Mock.html#t:exposes_option/0"},{"type":"type","title":"Patch.Mock.history_limit_option/0","doc":"This history_limit option controls how large of a history a mock should store It defaults to :infinity which will store an unlimited history.","ref":"Patch.Mock.html#t:history_limit_option/0"},{"type":"type","title":"Patch.Mock.option/0","doc":"Sum-type of all valid options","ref":"Patch.Mock.html#t:option/0"},{"type":"module","title":"Patch.Mock.History","doc":"","ref":"Patch.Mock.History.html"},{"type":"function","title":"Patch.Mock.History.entries/2","doc":"","ref":"Patch.Mock.History.html#entries/2"},{"type":"function","title":"Patch.Mock.History.new/1","doc":"","ref":"Patch.Mock.History.html#new/1"},{"type":"function","title":"Patch.Mock.History.put/3","doc":"","ref":"Patch.Mock.History.html#put/3"},{"type":"type","title":"Patch.Mock.History.argument/0","doc":"","ref":"Patch.Mock.History.html#t:argument/0"},{"type":"type","title":"Patch.Mock.History.entry/0","doc":"","ref":"Patch.Mock.History.html#t:entry/0"},{"type":"type","title":"Patch.Mock.History.limit/0","doc":"","ref":"Patch.Mock.History.html#t:limit/0"},{"type":"type","title":"Patch.Mock.History.name/0","doc":"","ref":"Patch.Mock.History.html#t:name/0"},{"type":"type","title":"Patch.Mock.History.sorting/0","doc":"","ref":"Patch.Mock.History.html#t:sorting/0"},{"type":"type","title":"Patch.Mock.History.t/0","doc":"","ref":"Patch.Mock.History.html#t:t/0"},{"type":"module","title":"Patch.Mock.History.Tagged","doc":"","ref":"Patch.Mock.History.Tagged.html"},{"type":"function","title":"Patch.Mock.History.Tagged.any?/1","doc":"Determine if any of the entries have been tagged in the affirmative","ref":"Patch.Mock.History.Tagged.html#any?/1"},{"type":"function","title":"Patch.Mock.History.Tagged.count/1","doc":"Calculates the count of entries that have been tagged in the affirmative","ref":"Patch.Mock.History.Tagged.html#count/1"},{"type":"function","title":"Patch.Mock.History.Tagged.first/1","doc":"Returns the first entry that was tagged in the affirmative","ref":"Patch.Mock.History.Tagged.html#first/1"},{"type":"macro","title":"Patch.Mock.History.Tagged.for_call/2","doc":"Construct a new Tagged History from a History and a Call. Every entry in the History will be tagged with either true if the entry matches the provided call or false if the entry does not match.","ref":"Patch.Mock.History.Tagged.html#for_call/2"},{"type":"function","title":"Patch.Mock.History.Tagged.for_function/2","doc":"Construct a new Tagged History from a History and a Function Name. Every entry in the History will be tagged with either true if the entry matches the provided Function Name or false if the entry does not match.","ref":"Patch.Mock.History.Tagged.html#for_function/2"},{"type":"function","title":"Patch.Mock.History.Tagged.format/2","doc":"","ref":"Patch.Mock.History.Tagged.html#format/2"},{"type":"function","title":"Patch.Mock.History.Tagged.tag/1","doc":"Returns the tag for the given tagged entry","ref":"Patch.Mock.History.Tagged.html#tag/1"},{"type":"type","title":"Patch.Mock.History.Tagged.entry/0","doc":"","ref":"Patch.Mock.History.Tagged.html#t:entry/0"},{"type":"type","title":"Patch.Mock.History.Tagged.t/0","doc":"","ref":"Patch.Mock.History.Tagged.html#t:t/0"},{"type":"type","title":"Patch.Mock.History.Tagged.tag/0","doc":"","ref":"Patch.Mock.History.Tagged.html#t:tag/0"},{"type":"module","title":"Patch.Mock.Naming","doc":"","ref":"Patch.Mock.Naming.html"},{"type":"function","title":"Patch.Mock.Naming.delegate/1","doc":"Canonical name for the delegate module for a provided module.","ref":"Patch.Mock.Naming.html#delegate/1"},{"type":"function","title":"Patch.Mock.Naming.facade/1","doc":"Canonical name for the facade module for a provided module. The facade module simply takes on the name of the provided module.","ref":"Patch.Mock.Naming.html#facade/1"},{"type":"function","title":"Patch.Mock.Naming.frozen/1","doc":"Canonical name for the frozen module for a provided module.","ref":"Patch.Mock.Naming.html#frozen/1"},{"type":"function","title":"Patch.Mock.Naming.original/1","doc":"Canonical name for the original module for a provided module.","ref":"Patch.Mock.Naming.html#original/1"},{"type":"function","title":"Patch.Mock.Naming.server/1","doc":"Canonical name for the server process for a provided module.","ref":"Patch.Mock.Naming.html#server/1"},{"type":"module","title":"Patch.Mock.Server","doc":"","ref":"Patch.Mock.Server.html"},{"type":"function","title":"Patch.Mock.Server.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Patch.Mock.Server.html#child_spec/1"},{"type":"function","title":"Patch.Mock.Server.delegate/3","doc":"Delegates a call to a mocked module through the server so it can optionally respond with a mock value.","ref":"Patch.Mock.Server.html#delegate/3"},{"type":"function","title":"Patch.Mock.Server.do_restore/1","doc":"","ref":"Patch.Mock.Server.html#do_restore/1"},{"type":"function","title":"Patch.Mock.Server.do_restore/2","doc":"","ref":"Patch.Mock.Server.html#do_restore/2"},{"type":"function","title":"Patch.Mock.Server.expose/2","doc":"","ref":"Patch.Mock.Server.html#expose/2"},{"type":"function","title":"Patch.Mock.Server.history/1","doc":"Retrieves the call history for a mock","ref":"Patch.Mock.Server.html#history/1"},{"type":"function","title":"Patch.Mock.Server.init/1","doc":"Callback implementation for GenServer.init/1 .","ref":"Patch.Mock.Server.html#init/1"},{"type":"function","title":"Patch.Mock.Server.register/3","doc":"Registers a mock value to be returned whenever the specified function is called on the module.","ref":"Patch.Mock.Server.html#register/3"},{"type":"function","title":"Patch.Mock.Server.restore/1","doc":"Restores a module to its original state.","ref":"Patch.Mock.Server.html#restore/1"},{"type":"function","title":"Patch.Mock.Server.restore/2","doc":"Restores a function in a module to its original state","ref":"Patch.Mock.Server.html#restore/2"},{"type":"function","title":"Patch.Mock.Server.start_link/2","doc":"","ref":"Patch.Mock.Server.html#start_link/2"},{"type":"type","title":"Patch.Mock.Server.option/0","doc":"Sum-type of all valid options","ref":"Patch.Mock.Server.html#t:option/0"},{"type":"type","title":"Patch.Mock.Server.t/0","doc":"","ref":"Patch.Mock.Server.html#t:t/0"},{"type":"module","title":"Patch.Mock.Supervisor","doc":"","ref":"Patch.Mock.Supervisor.html"},{"type":"function","title":"Patch.Mock.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Patch.Mock.Supervisor.html#child_spec/1"},{"type":"function","title":"Patch.Mock.Supervisor.init/1","doc":"Callback implementation for DynamicSupervisor.init/1 .","ref":"Patch.Mock.Supervisor.html#init/1"},{"type":"function","title":"Patch.Mock.Supervisor.start_child/2","doc":"","ref":"Patch.Mock.Supervisor.html#start_child/2"},{"type":"function","title":"Patch.Mock.Supervisor.start_link/1","doc":"","ref":"Patch.Mock.Supervisor.html#start_link/1"},{"type":"module","title":"Patch.Mock.Code","doc":"Patch mocks out modules by generating mock modules and recompiling them for a target module. Patch's approach to mocking a module provides some powerful affordances. Private functions can be mocked. Internal function calls are effected by mocks regardless of the function's visibility without having to change the way code is written. Private functions can be optionally exposed in the facade to make it possible to test a private function directly without changing its visibility in code. Mocking Strategy There are 4 logical modules and 1 GenServer that are involved when mocking a module. The 4 logical modules: target - The module to be mocked. facade - The target module is replaced by a facade module that intercepts all external calls and redirects them to the delegate module. original - The target module is preserved as the original module, with the important transformation that all local calls are redirected to the delegate module. delegate - This module is responsible for checking with the server to see if a call is mocked and should be intercepted. If so, the mock value is returned, otherwise the original function is called. Each target module has an associated GenServer, a Patch.Mock.Server that has keeps state about the history of function calls and holds the mock data to be returned on interception. See Patch.Mock.Server for more information. Example Target Module To better understand how Patch works, consider the following example module. defmodule Example do def public_function ( argument_1 , argument_2 ) do { :public , private_function ( argument_1 , argument_2 ) } end defp private_function ( argument_1 , argument_2 ) do { :private , argument_1 , argument_2 } end end facade module The facade module is automatically generated based off the exports of the target module. It takes on the name of the provided module. For each exported function, a function is generated in the facade module that calls the delegate module. defmodule Example do def public_function ( argument_1 , argument_2 ) do Patch.Mock.Delegate.For.Example . public_function ( argument_1 , argument_2 ) end end delegate module The delegate module is automatically generated based off all the functions of the target module. It takes on a name based off the target module, see Patch.Mock.Naming.delegate/1 . For each function, a function is generated in the delegate module that calls Patch.Mock.Server.delegate/3 delegating to the server named for the target module, see Patch.Mock.Naming.server/1 . defmodule Patch.Mock.Delegate.For.Example do def public_function ( argument_1 , argument_2 ) do Patch.Mock.Server . delegate ( Patch.Mock.Server.For.Example , :public_function , [ argument_1 , argument_2 ] ) end def private_function ( argument_1 , argument_2 ) do Patch.Mock.Server . delegate ( Patch.Mock.Server.For.Example , :private_function , [ argument_1 , argument_2 ] ) end end original module The original module takes on a name based off the provided module, see Patch.Mock.Naming.original/1 . The code is transformed in the following ways. All local calls are converted into remote calls to the delegate module. All functions are exported defmodule Patch.Mock.Original.For.Example do def public_function ( argument_1 , argument_2 ) do { :public , Patch.Mock.Delegate.For.Example . private_function ( argument_1 , argument_2 ) } end def private_function ( argument_1 , argument_2 ) do { :private , argument_1 , argument_2 } end end External Function Calls First, let's examine how calls from outside the module are treated. Public Function Calls Code calling Example.public_function/2 has the following call flow. [Caller] -&gt; facade -&gt; delegate -&gt; server -&gt; mocked? -&gt; yes (Intercepted) [Mock Value] &lt;----------------------------|----' -&gt; no -&gt; original (Run Original Code) [Original Value] &lt;--------------------------------------' Calling a public function will either return the mocked value if it exists, or fall back to calling the original function. Private Function Calls Code calling Example.private_function/2 has the following call flow. [Caller] --------------------------&gt; facade [UndefinedFunctionError] &lt;-----' Calling a private function continues to be an error from the external caller's point of view. The expose option does allow the facade to expose private functions, in those cases the call flow just follows the public call flow. Internal Calls Next, let's examine how calls from outside the module are treated. Public Function Calls Code in the original module calling public functions have their code transformed to call the delegate module. original -&gt; delegate -&gt; server -&gt; mocked? -&gt; yes (Intercepted) [Mock Value] &lt;------------------|----' -&gt; no -&gt; original (Run Original Code) [Original Value] &lt;----------------------------' Since the call is redirected to the delegate , calling a public function will either return the mocked value if it exists, or fall back to calling the original function. Private Function Call Flow Code in the original module calling private functions have their code transformed to call the delegate module original -&gt; delegate -&gt; server -&gt; mocked? -&gt; yes (Intercepted) [Mock Value] &lt;------------------|----' -&gt; no -&gt; original (Run Original Code) [Original Value] &lt;----------------------------' Since the call is redirected to the delegate , calling a private function will either return the mocked value if it exists, or fall back to calling the original function. Code Generation For additional details on how Code Generation works, see the Patch.Mock.Code.Generate module.","ref":"Patch.Mock.Code.html"},{"type":"function","title":"Patch.Mock.Code.abstract_forms/1","doc":"Extracts the abstract_forms from a module","ref":"Patch.Mock.Code.html#abstract_forms/1"},{"type":"function","title":"Patch.Mock.Code.attributes/1","doc":"Extracts the attribtues from a module","ref":"Patch.Mock.Code.html#attributes/1"},{"type":"function","title":"Patch.Mock.Code.classify_export/3","doc":"Classifies an exported mfa into one of the following classifications :builtin - Export is a BIF. :generated - Export is a generated function. :normal - Export is a user defined function.","ref":"Patch.Mock.Code.html#classify_export/3"},{"type":"function","title":"Patch.Mock.Code.compile/2","doc":"Compiles the provided abstract_form with the given compiler_options In addition to compiling, the module will be loaded.","ref":"Patch.Mock.Code.html#compile/2"},{"type":"function","title":"Patch.Mock.Code.compiler_options/1","doc":"Extracts the compiler options from a module.","ref":"Patch.Mock.Code.html#compiler_options/1"},{"type":"function","title":"Patch.Mock.Code.exports/3","doc":"Extracts the exports from the provided abstract_forms for the module. The exports returned can be controlled by the exposes argument.","ref":"Patch.Mock.Code.html#exports/3"},{"type":"function","title":"Patch.Mock.Code.filter_exports/3","doc":"Given a module and a list of exports filters the list of exports to those that have the given classification. See classify_export/3 for information about export classification","ref":"Patch.Mock.Code.html#filter_exports/3"},{"type":"function","title":"Patch.Mock.Code.freeze/1","doc":"Freezes a module by generating a copy of it under a frozen name with all remote calls to the target module re-routed to the frozen module.","ref":"Patch.Mock.Code.html#freeze/1"},{"type":"function","title":"Patch.Mock.Code.module/2","doc":"Mocks a module by generating a set of modules based on the target module. The target module's Unit is returned on success.","ref":"Patch.Mock.Code.html#module/2"},{"type":"function","title":"Patch.Mock.Code.purge/1","doc":"Purges a module from the code server","ref":"Patch.Mock.Code.html#purge/1"},{"type":"function","title":"Patch.Mock.Code.stick_module/1","doc":"Marks a module a sticky","ref":"Patch.Mock.Code.html#stick_module/1"},{"type":"function","title":"Patch.Mock.Code.unstick_module/1","doc":"Unsticks a module Returns {:ok, was_sticky?} on success, {:error, reason} otherwise","ref":"Patch.Mock.Code.html#unstick_module/1"},{"type":"type","title":"Patch.Mock.Code.binary_error/0","doc":"","ref":"Patch.Mock.Code.html#t:binary_error/0"},{"type":"type","title":"Patch.Mock.Code.chunk_error/0","doc":"","ref":"Patch.Mock.Code.html#t:chunk_error/0"},{"type":"type","title":"Patch.Mock.Code.compiler_option/0","doc":"","ref":"Patch.Mock.Code.html#t:compiler_option/0"},{"type":"type","title":"Patch.Mock.Code.export_classification/0","doc":"","ref":"Patch.Mock.Code.html#t:export_classification/0"},{"type":"type","title":"Patch.Mock.Code.exports/0","doc":"","ref":"Patch.Mock.Code.html#t:exports/0"},{"type":"type","title":"Patch.Mock.Code.form/0","doc":"","ref":"Patch.Mock.Code.html#t:form/0"},{"type":"type","title":"Patch.Mock.Code.load_error/0","doc":"","ref":"Patch.Mock.Code.html#t:load_error/0"},{"type":"type","title":"Patch.Mock.Code.option/0","doc":"Sum-type of all valid options","ref":"Patch.Mock.Code.html#t:option/0"},{"type":"module","title":"Patch.Mock.Code.Freezer","doc":"The Code Freezer is a registry that can be used to register and use modules that might be frozen. Modules that Patch relies on must be freezable so that the end-user can Patch them and the frozen versions are still available for internal use.","ref":"Patch.Mock.Code.Freezer.html"},{"type":"function","title":"Patch.Mock.Code.Freezer.empty/0","doc":"Destroy all frozen modules","ref":"Patch.Mock.Code.Freezer.html#empty/0"},{"type":"function","title":"Patch.Mock.Code.Freezer.get/1","doc":"Get the possibly-frozen module to use for a module. If the module is frozen then the frozen name will be returned. If the module is not frozen then the module is returned.s","ref":"Patch.Mock.Code.Freezer.html#get/1"},{"type":"function","title":"Patch.Mock.Code.Freezer.put/1","doc":"Puts a module into the freezer. The module must be freezable. Repeated calls for frozen modules are no-ops.","ref":"Patch.Mock.Code.Freezer.html#put/1"},{"type":"module","title":"Patch.Mock.Code.Generate","doc":"This module provides the ability to generate derivative modules based on a target module. This module delegates code generation to purpose specific Generator modules, see those modules for additional details on how specific generation works. Patch.Mock.Code.Generators.Delegate for how delegate modules are generated Patch.Mock.Code.Generators.Facade for how facade modules are generated Patch.Mock.Code.Generators.Frozen for how frozen modules are generated Patch.Mock.Code.Generators.Original for how original modules are generated","ref":"Patch.Mock.Code.Generate.html"},{"type":"function","title":"Patch.Mock.Code.Generate.delegate/3","doc":"See Patch.Mock.Code.Generators.Delegate.generate/3 .","ref":"Patch.Mock.Code.Generate.html#delegate/3"},{"type":"function","title":"Patch.Mock.Code.Generate.facade/3","doc":"See Patch.Mock.Code.Generators.Facade.generate/3 .","ref":"Patch.Mock.Code.Generate.html#facade/3"},{"type":"function","title":"Patch.Mock.Code.Generate.frozen/2","doc":"See Patch.Mock.Code.Generators.Frozen.generate/2 .","ref":"Patch.Mock.Code.Generate.html#frozen/2"},{"type":"function","title":"Patch.Mock.Code.Generate.original/3","doc":"See Patch.Mock.Code.Generators.Original.generate/3 .","ref":"Patch.Mock.Code.Generate.html#original/3"},{"type":"module","title":"Patch.Mock.Code.Query","doc":"This module provides the ability to query abstract forms. This module delegates queries to purpose specific Queries modules, see those modules for additional details on how specific queries work. Patch.Mock.Code.Queries.Exports for how exports are queried Patch.Mock.Code.Queries.Functions for how functions are queried","ref":"Patch.Mock.Code.Query.html"},{"type":"function","title":"Patch.Mock.Code.Query.exports/1","doc":"See Patch.Mock.Code.Queries.Exports.query/1 .","ref":"Patch.Mock.Code.Query.html#exports/1"},{"type":"function","title":"Patch.Mock.Code.Query.functions/1","doc":"See Patch.Mock.Code.Queries.Functions.query/1 .","ref":"Patch.Mock.Code.Query.html#functions/1"},{"type":"module","title":"Patch.Mock.Code.Transform","doc":"This module provides the ability to transform abstract forms. This module delegates transformation to purpose specific Transforms modules, see those modules for additional details on how specific transformations work. Patch.Mock.Code.Transforms.Clean for how a module is prepared for generation. Patch.Mock.Code.Transforms.Export for how exports are rewritten Patch.Mock.Code.Transforms.Filter for how functions are filtered Patch.Mock.Code.Transforms.Remote for how local calls are made remote Patch.Mock.Code.Transforms.Rename for how a module is renamed Patch.Mock.Code.Transforms.Reroute for how remote calls are rerouted","ref":"Patch.Mock.Code.Transform.html"},{"type":"function","title":"Patch.Mock.Code.Transform.clean/1","doc":"See Patch.Mock.Code.Transforms.Clean.transform/1 .","ref":"Patch.Mock.Code.Transform.html#clean/1"},{"type":"function","title":"Patch.Mock.Code.Transform.export/2","doc":"See Patch.Mock.Code.Transforms.Export.transform/2 .","ref":"Patch.Mock.Code.Transform.html#export/2"},{"type":"function","title":"Patch.Mock.Code.Transform.filter/2","doc":"See Patch.Mock.Code.Transforms.Filter.transform/2 .","ref":"Patch.Mock.Code.Transform.html#filter/2"},{"type":"function","title":"Patch.Mock.Code.Transform.remote/2","doc":"See Patch.Mock.Code.Transforms.Remote.transform/2 .","ref":"Patch.Mock.Code.Transform.html#remote/2"},{"type":"function","title":"Patch.Mock.Code.Transform.rename/2","doc":"See Patch.Mock.Code.Transforms.Rename.transform/2 .","ref":"Patch.Mock.Code.Transform.html#rename/2"},{"type":"function","title":"Patch.Mock.Code.Transform.reroute/3","doc":"See Patch.Mock.Code.Transforms.Reroute.transform/3 .","ref":"Patch.Mock.Code.Transform.html#reroute/3"},{"type":"module","title":"Patch.Mock.Code.Unit","doc":"","ref":"Patch.Mock.Code.Unit.html"},{"type":"function","title":"Patch.Mock.Code.Unit.purge/1","doc":"","ref":"Patch.Mock.Code.Unit.html#purge/1"},{"type":"function","title":"Patch.Mock.Code.Unit.restore/1","doc":"","ref":"Patch.Mock.Code.Unit.html#restore/1"},{"type":"type","title":"Patch.Mock.Code.Unit.t/0","doc":"","ref":"Patch.Mock.Code.Unit.html#t:t/0"},{"type":"module","title":"Patch.Mock.Code.Generators.Delegate","doc":"Generator for delegate modules. delegate modules are generated by taking the target module and creating a stub function for each function in the module that calls the Patch.Mock.Server 's delegate/3 function. The delegate module will also expose every function in the module regardless of the original visibility.","ref":"Patch.Mock.Code.Generators.Delegate.html"},{"type":"function","title":"Patch.Mock.Code.Generators.Delegate.generate/3","doc":"Generates a new delegate module based on the forms of a provided module.","ref":"Patch.Mock.Code.Generators.Delegate.html#generate/3"},{"type":"module","title":"Patch.Mock.Code.Generators.Facade","doc":"Generator for facade modules. facade modules are generated by taking the target module and creating a stub function for each function in the module that calls the delegate modules corresponding function. The facade module can optionally expose private functions as public.","ref":"Patch.Mock.Code.Generators.Facade.html"},{"type":"function","title":"Patch.Mock.Code.Generators.Facade.generate/3","doc":"Generates a new facade module based on the forms of the provided module.","ref":"Patch.Mock.Code.Generators.Facade.html#generate/3"},{"type":"module","title":"Patch.Mock.Code.Generators.Frozen","doc":"Generator for frozen modules. frozen modules are generated by taking the target module and renaming it and ensuring that any call in the module to itself is sent to the frozen module and not the provided module. The frozen module simple acts as a way to call the unaltered original code. It is only used internally to preserve the GenServer module since the internal implementation requires that GenServer work as expected.","ref":"Patch.Mock.Code.Generators.Frozen.html"},{"type":"function","title":"Patch.Mock.Code.Generators.Frozen.generate/2","doc":"Generates a new frozen module based on the forms of a provided module.","ref":"Patch.Mock.Code.Generators.Frozen.html#generate/2"},{"type":"module","title":"Patch.Mock.Code.Generators.Original","doc":"","ref":"Patch.Mock.Code.Generators.Original.html"},{"type":"function","title":"Patch.Mock.Code.Generators.Original.generate/3","doc":"Generates a new original module based on the forms of the provided module.","ref":"Patch.Mock.Code.Generators.Original.html#generate/3"},{"type":"module","title":"Patch.Mock.Code.Queries.Exports","doc":"","ref":"Patch.Mock.Code.Queries.Exports.html"},{"type":"function","title":"Patch.Mock.Code.Queries.Exports.query/1","doc":"Queries the provided forms for the exported functions.","ref":"Patch.Mock.Code.Queries.Exports.html#query/1"},{"type":"module","title":"Patch.Mock.Code.Queries.Functions","doc":"","ref":"Patch.Mock.Code.Queries.Functions.html"},{"type":"function","title":"Patch.Mock.Code.Queries.Functions.query/1","doc":"Queries the provided forms for all defined functions.","ref":"Patch.Mock.Code.Queries.Functions.html#query/1"},{"type":"module","title":"Patch.Mock.Code.Transforms.Clean","doc":"Cleans abstract form to prepare it for subsequent generation. The following forms are retained: module attribute exports no_auto_import compiler options (This is needed to prevent R14 shadow import warnings) functions","ref":"Patch.Mock.Code.Transforms.Clean.html"},{"type":"function","title":"Patch.Mock.Code.Transforms.Clean.transform/1","doc":"","ref":"Patch.Mock.Code.Transforms.Clean.html#transform/1"},{"type":"module","title":"Patch.Mock.Code.Transforms.Export","doc":"","ref":"Patch.Mock.Code.Transforms.Export.html"},{"type":"function","title":"Patch.Mock.Code.Transforms.Export.transform/2","doc":"Transforms the provided forms to export the given list of functions.","ref":"Patch.Mock.Code.Transforms.Export.html#transform/2"},{"type":"module","title":"Patch.Mock.Code.Transforms.Filter","doc":"Filters the functions and specifications in a module to the exports provided.","ref":"Patch.Mock.Code.Transforms.Filter.html"},{"type":"function","title":"Patch.Mock.Code.Transforms.Filter.transform/2","doc":"","ref":"Patch.Mock.Code.Transforms.Filter.html#transform/2"},{"type":"module","title":"Patch.Mock.Code.Transforms.Remote","doc":"","ref":"Patch.Mock.Code.Transforms.Remote.html"},{"type":"function","title":"Patch.Mock.Code.Transforms.Remote.transform/2","doc":"Transforms the provided forms to rewrite any local call into a remote call to the provided module .","ref":"Patch.Mock.Code.Transforms.Remote.html#transform/2"},{"type":"module","title":"Patch.Mock.Code.Transforms.Rename","doc":"","ref":"Patch.Mock.Code.Transforms.Rename.html"},{"type":"function","title":"Patch.Mock.Code.Transforms.Rename.transform/2","doc":"Transforms the provided forms to rename the module to the provided module name.","ref":"Patch.Mock.Code.Transforms.Rename.html#transform/2"},{"type":"module","title":"Patch.Mock.Code.Transforms.Reroute","doc":"","ref":"Patch.Mock.Code.Transforms.Reroute.html"},{"type":"function","title":"Patch.Mock.Code.Transforms.Reroute.transform/3","doc":"Transforms the provided forms to rewrite any remote calls to the source module into remote calls to the destination module.","ref":"Patch.Mock.Code.Transforms.Reroute.html#transform/3"},{"type":"module","title":"Patch.Mock.Value","doc":"Interface for generating mock values. In a test this module is imported into the test and so using this module directly is not necessary.","ref":"Patch.Mock.Value.html"},{"type":"function","title":"Patch.Mock.Value.advance/1","doc":"Advances the given value. Sequences and Cycles both have meaningful advances, all other values types this acts as a no-op.","ref":"Patch.Mock.Value.html#advance/1"},{"type":"function","title":"Patch.Mock.Value.callable/1","doc":"Create a new Values.Callable to be used as the mock value. When a patched function has a Values.Callable as its mock value, it will invoke the callable with the arguments to the patched function on every invocation to generate a new value to return. patch ( Example , :example , callable ( fn arg -&gt; { :patched , arg } end ) ) assert Example . example ( 1 ) == { :patched , 1 } # passes assert Example . example ( 2 ) == { :patched , 2 } # passes assert Example . example ( 3 ) == { :patched , 3 } # passes Any function literal will automatically be promoted into a Values.Callable unless it is wrapped in a scalar/1 call. See callable/2 for more configuration options. callable/1 calls use the default configuration options dispatch: :apply evaluate: :passthrough","ref":"Patch.Mock.Value.html#callable/1"},{"type":"function","title":"Patch.Mock.Value.callable/2","doc":"callable/2 allows the test author to provide additional configuration. There are two options :dispatch Controls how the arguments are dispatched to the callable. :apply is the default. It will call the function with the same arity as the incoming call. :list will always call the callable with a single argument, a list of all the incoming arguments. Apply Example patch ( Example , :example , callable ( fn a , b , c -&gt; { :patched , a , b , c } end ) , :apply ) assert Example . example ( 1 , 2 , 3 ) == { :patched , 1 , 2 , 3 } # passes List Example patch ( Example , :example , callable ( fn [ a , b , c ] -&gt; { :patched , a , b , c } [ a ] -&gt; { :patched , a } end , :list ) ) assert Example . example ( 1 , 2 , 3 ) == { :patched , 1 , 2 , 3 } # passes assert Example . example ( 1 ) == { :patched , 1 } # passes :evaluate Controls how the callable is evaluated. :passthrough is the default. It will passthrough to the original function if the provided callable fails to pattern match to the incoming call :strict will bubble up any BadArityError or FunctionClauseErrors . Legacy Configuration Behavior (may be deprecated) This function accepts either a single atom, in which case it will assign that to the :dispatch configuration and use the default :evaluate option. The following calls are equivalent # Using legacy configuration convention patch ( Example , :example , callable ( fn args -&gt; { :patched , args } , :apply ) ) # Using explicit options without evaluate patch ( Example , :example , callable ( fn args -&gt; { :patched , args } , dispatch : :apply ) ) # Using fully specified explicit options patch ( Example , :example , callable ( fn args -&gt; { :patched , args } , dispatch : :apply , evaluate : :passthrough ) ) Multiple Arities dispatch: :list used to be the preferred way to deal with multiple arities, here's an example. patch ( Example , :example , callable ( fn [ a ] -&gt; { :patched , a } [ a , b , c ] -&gt; { :patched , a , b , c } end , dispatch : :list ) ) assert Example . example ( 1 ) == { :patched , 1 } assert Example . example ( 1 , 2 , 3 ) == { :patched , 1 , 2 , 3 } Patch now has &quot;Stacked Callables&quot; so the preferred method is to use the equivalent code patch ( Example , :example , fn a -&gt; { :patched , a } end ) patch ( Example , :example , fn a , b , c -&gt; { :patched , a , b , c } end ) assert Example . example ( 1 ) == { :patched , 1 } assert Example . example ( 1 , 2 , 3 ) == { :patched , 1 , 2 , 3 }","ref":"Patch.Mock.Value.html#callable/2"},{"type":"function","title":"Patch.Mock.Value.cycle/1","doc":"Create a new Values.Cycle to be used as the mock value. When a patched function has a Values.Cycle as its mock value, it will provide the first value in the cycle and then move the first value to the end of the cycle on every invocation. Consider a function patched with cycle([1, 2, 3]) via the following code patch ( Example , :example , cycle ( [ 1 , 2 , 3 ] ) ) Invocation Cycle Before Call Return Value Cycle After Call 1 [1, 2, 3] 1 [2, 3, 1] 2 [2, 3, 1] 2 [3, 1, 2] 3 [3, 1, 2] 3 [1, 2, 3] 4 [1, 2, 3] 1 [2, 3, 1] 5 [2, 3, 1] 2 [3, 1, 2] 6 [3, 1, 2] 3 [1, 2, 3] 7 [1, 2, 3] 1 [2, 3, 1] We could continue the above table forever since the cycle will repeat endlessly. Cycles can contain callable/1,2 , raise/1,2 and throw/1 mock values.","ref":"Patch.Mock.Value.html#cycle/1"},{"type":"macro","title":"Patch.Mock.Value.is_value/1","doc":"Guard that checks whether a value is a proper Values module","ref":"Patch.Mock.Value.html#is_value/1"},{"type":"function","title":"Patch.Mock.Value.next/2","doc":"Generate the next return value and advance the underlying value.","ref":"Patch.Mock.Value.html#next/2"},{"type":"function","title":"Patch.Mock.Value.raises/1","doc":"Creates a special value that raises a RuntimeError with the given message. patch ( Example , :example , raises ( &quot;patched&quot; ) ) assert_raise RuntimeError , &quot;patched&quot; , fn -&gt; Example . example ( ) end","ref":"Patch.Mock.Value.html#raises/1"},{"type":"function","title":"Patch.Mock.Value.raises/2","doc":"Creates a special value that raises the given exception with the provided attributes. patch ( Example , :example , raises ( ArgumentError , message : &quot;patched&quot; ) ) assert_raise ArgumentError , &quot;patched&quot; , fn -&gt; Example . example ( ) end","ref":"Patch.Mock.Value.html#raises/2"},{"type":"function","title":"Patch.Mock.Value.scalar/1","doc":"Creates a new Values.Scalar to be used as the mock value. When a patched function has a Values.Scalar as its mock value, it will provide the scalar value on every invocation patch ( Example , :example , scalar ( :patched ) ) assert Example . example ( ) == :patched # passes assert Example . example ( ) == :patched # passes assert Example . example ( ) == :patched # passes When patching with any term that isn't a function, it will automatically be promoted into a Values.Scalar . patch ( Example , :example , :patched ) assert Example . example ( ) == :patched # passes assert Example . example ( ) == :patched # passes assert Example . example ( ) == :patched # passes Since functions are always automatically promoted to Values.Callable , if a function is meant as a scalar value it must be wrapped in a call to scalar/1 . patch ( Example , :get_name_normalizer , scalar ( &amp; String . downcase / 1 ) ) assert Example . get_name_normalizer == &amp; String . downcase / 1 # passes","ref":"Patch.Mock.Value.html#scalar/1"},{"type":"function","title":"Patch.Mock.Value.sequence/1","doc":"Creates a new Values.Sequence to be used as a mock value. When a patched function has a Values.Sequence as its mock value, it will provide the first value in the sequence as the return value and then discard the first value. Once the sequence is down to a final value it will be retained and returned on every subsequent invocation. Consider a function patched with sequence([1, 2, 3]) via the following code patch ( Example , :example , sequence ( [ 1 , 2 , 3 ] ) ) Invocation Sequence Before Call Return Value Sequence After Call 1 [1, 2, 3] 1 [2, 3] 2 [2, 3] 2 [3] 3 [3] 3 [3] 4 [3] 3 [3] 5 [3] 3 [3] We could continue the above table forever since the sequence will continue to return the last value endlessly. Sequences can contain callable/1,2 , raise/1,2 and throw/1 mock values. There is one special behavior of sequence, and that's an empty sequence, which always returns the value nil on every invocation. If the test author would like to simulate an exhaustable sequence, one that returns a set number of items and then responds to every other call with nil , they can simply add a nil as the last element in the sequence patch ( Example , :example , sequence ( [ 1 , 2 , 3 , nil ] ) Invocation Sequence Before Call Return Value Sequence After Call 1 [1, 2, 3, nil] 1 [2, 3, nil] 2 [2, 3, nil] 2 [3, nil] 3 [3, nil] 3 [nil] 4 [nil] nil [nil] 5 [nil] nil [nil]","ref":"Patch.Mock.Value.html#sequence/1"},{"type":"function","title":"Patch.Mock.Value.throws/1","doc":"Creates a special values that throws the provided value when evaluated. patch ( Example , :example , throws ( :patched ) ) assert catch_throw ( Example . example ( ) ) == :patched","ref":"Patch.Mock.Value.html#throws/1"},{"type":"type","title":"Patch.Mock.Value.t/0","doc":"","ref":"Patch.Mock.Value.html#t:t/0"},{"type":"module","title":"Patch.Mock.Values.Callable","doc":"","ref":"Patch.Mock.Values.Callable.html"},{"type":"function","title":"Patch.Mock.Values.Callable.advance/1","doc":"","ref":"Patch.Mock.Values.Callable.html#advance/1"},{"type":"function","title":"Patch.Mock.Values.Callable.new/2","doc":"","ref":"Patch.Mock.Values.Callable.html#new/2"},{"type":"function","title":"Patch.Mock.Values.Callable.next/2","doc":"","ref":"Patch.Mock.Values.Callable.html#next/2"},{"type":"type","title":"Patch.Mock.Values.Callable.dispatch_mode/0","doc":"","ref":"Patch.Mock.Values.Callable.html#t:dispatch_mode/0"},{"type":"type","title":"Patch.Mock.Values.Callable.dispatch_option/0","doc":"","ref":"Patch.Mock.Values.Callable.html#t:dispatch_option/0"},{"type":"type","title":"Patch.Mock.Values.Callable.evaluate_mode/0","doc":"","ref":"Patch.Mock.Values.Callable.html#t:evaluate_mode/0"},{"type":"type","title":"Patch.Mock.Values.Callable.evaluate_option/0","doc":"","ref":"Patch.Mock.Values.Callable.html#t:evaluate_option/0"},{"type":"type","title":"Patch.Mock.Values.Callable.option/0","doc":"","ref":"Patch.Mock.Values.Callable.html#t:option/0"},{"type":"type","title":"Patch.Mock.Values.Callable.t/0","doc":"","ref":"Patch.Mock.Values.Callable.html#t:t/0"},{"type":"module","title":"Patch.Mock.Values.CallableStack","doc":"","ref":"Patch.Mock.Values.CallableStack.html"},{"type":"function","title":"Patch.Mock.Values.CallableStack.advance/1","doc":"","ref":"Patch.Mock.Values.CallableStack.html#advance/1"},{"type":"function","title":"Patch.Mock.Values.CallableStack.new/1","doc":"","ref":"Patch.Mock.Values.CallableStack.html#new/1"},{"type":"function","title":"Patch.Mock.Values.CallableStack.next/2","doc":"","ref":"Patch.Mock.Values.CallableStack.html#next/2"},{"type":"function","title":"Patch.Mock.Values.CallableStack.push/2","doc":"","ref":"Patch.Mock.Values.CallableStack.html#push/2"},{"type":"type","title":"Patch.Mock.Values.CallableStack.t/0","doc":"","ref":"Patch.Mock.Values.CallableStack.html#t:t/0"},{"type":"module","title":"Patch.Mock.Values.Cycle","doc":"","ref":"Patch.Mock.Values.Cycle.html"},{"type":"function","title":"Patch.Mock.Values.Cycle.advance/1","doc":"","ref":"Patch.Mock.Values.Cycle.html#advance/1"},{"type":"function","title":"Patch.Mock.Values.Cycle.new/1","doc":"","ref":"Patch.Mock.Values.Cycle.html#new/1"},{"type":"function","title":"Patch.Mock.Values.Cycle.next/2","doc":"","ref":"Patch.Mock.Values.Cycle.html#next/2"},{"type":"type","title":"Patch.Mock.Values.Cycle.t/0","doc":"","ref":"Patch.Mock.Values.Cycle.html#t:t/0"},{"type":"module","title":"Patch.Mock.Values.Raises","doc":"","ref":"Patch.Mock.Values.Raises.html"},{"type":"function","title":"Patch.Mock.Values.Raises.advance/1","doc":"","ref":"Patch.Mock.Values.Raises.html#advance/1"},{"type":"function","title":"Patch.Mock.Values.Raises.new/1","doc":"","ref":"Patch.Mock.Values.Raises.html#new/1"},{"type":"function","title":"Patch.Mock.Values.Raises.new/2","doc":"","ref":"Patch.Mock.Values.Raises.html#new/2"},{"type":"function","title":"Patch.Mock.Values.Raises.next/2","doc":"","ref":"Patch.Mock.Values.Raises.html#next/2"},{"type":"type","title":"Patch.Mock.Values.Raises.t/0","doc":"","ref":"Patch.Mock.Values.Raises.html#t:t/0"},{"type":"module","title":"Patch.Mock.Values.Scalar","doc":"","ref":"Patch.Mock.Values.Scalar.html"},{"type":"function","title":"Patch.Mock.Values.Scalar.advance/1","doc":"","ref":"Patch.Mock.Values.Scalar.html#advance/1"},{"type":"function","title":"Patch.Mock.Values.Scalar.new/1","doc":"","ref":"Patch.Mock.Values.Scalar.html#new/1"},{"type":"function","title":"Patch.Mock.Values.Scalar.next/2","doc":"","ref":"Patch.Mock.Values.Scalar.html#next/2"},{"type":"type","title":"Patch.Mock.Values.Scalar.t/0","doc":"","ref":"Patch.Mock.Values.Scalar.html#t:t/0"},{"type":"module","title":"Patch.Mock.Values.Sequence","doc":"","ref":"Patch.Mock.Values.Sequence.html"},{"type":"function","title":"Patch.Mock.Values.Sequence.advance/1","doc":"","ref":"Patch.Mock.Values.Sequence.html#advance/1"},{"type":"function","title":"Patch.Mock.Values.Sequence.new/1","doc":"","ref":"Patch.Mock.Values.Sequence.html#new/1"},{"type":"function","title":"Patch.Mock.Values.Sequence.next/2","doc":"","ref":"Patch.Mock.Values.Sequence.html#next/2"},{"type":"type","title":"Patch.Mock.Values.Sequence.t/0","doc":"","ref":"Patch.Mock.Values.Sequence.html#t:t/0"},{"type":"module","title":"Patch.Mock.Values.Throws","doc":"","ref":"Patch.Mock.Values.Throws.html"},{"type":"function","title":"Patch.Mock.Values.Throws.advance/1","doc":"","ref":"Patch.Mock.Values.Throws.html#advance/1"},{"type":"function","title":"Patch.Mock.Values.Throws.new/1","doc":"","ref":"Patch.Mock.Values.Throws.html#new/1"},{"type":"function","title":"Patch.Mock.Values.Throws.next/2","doc":"","ref":"Patch.Mock.Values.Throws.html#next/2"},{"type":"type","title":"Patch.Mock.Values.Throws.t/0","doc":"","ref":"Patch.Mock.Values.Throws.html#t:t/0"},{"type":"module","title":"Patch.Access","doc":"","ref":"Patch.Access.html"},{"type":"function","title":"Patch.Access.fetch/2","doc":"","ref":"Patch.Access.html#fetch/2"},{"type":"function","title":"Patch.Access.get/3","doc":"","ref":"Patch.Access.html#get/3"},{"type":"function","title":"Patch.Access.put/3","doc":"","ref":"Patch.Access.html#put/3"},{"type":"module","title":"Patch.Apply","doc":"Utility module to assist with applying functions.","ref":"Patch.Apply.html"},{"type":"function","title":"Patch.Apply.safe/2","doc":"Safe application of an anonymous function. This is just like apply/2 but if the the anonymous function is unable to handle the call (raising either BadArityError or FunctionClauseError ) then the :error atom is returned. If the function evaluates successfully its reply is returned wrapped in an {:ok, result} tuple.","ref":"Patch.Apply.html#safe/2"},{"type":"module","title":"Patch.Assertions","doc":"","ref":"Patch.Assertions.html"},{"type":"function","title":"Patch.Assertions.assert_any_call/2","doc":"Asserts that the given module and function has been called with any arity. patch ( Example , :function , :patch ) Patch.Assertions . assert_any_call ( Example , :function ) # fails Example . function ( 1 , 2 , 3 ) Patch.Asertions . assert_any_call ( Example , :function ) # passes There are convenience delegates in the Developer Interface, Patch.assert_any_call/1 and Patch.assert_any_call/2 which should be preferred over calling this function directly.","ref":"Patch.Assertions.html#assert_any_call/2"},{"type":"macro","title":"Patch.Assertions.assert_called/1","doc":"Given a call will assert that a matching call was observed by the patched function. This macro fully supports patterns and will perform non-hygienic binding similar to ExUnit's assert_receive/3 and assert_received/2 . patch ( Example , :function , :patch ) Example . function ( 1 , 2 , 3 ) Patch.Assertions . assert_called ( Example , :function , [ 1 , 2 , 3 ] ) # passes Patch.Assertions . assert_called ( Example , :function , [ 1 , _ , 3 ] ) # passes Patch.Assertions . assert_called ( Example , :function , [ 4 , 5 , 6 ] ) # fails Patch.Assertions . assert_called ( Example , :function , [ 4 , _ , 6 ] ) # fails There is a convenience macro in the Developer Interface, Patch.assert_called/1 which should be preferred over calling this macro directly.","ref":"Patch.Assertions.html#assert_called/1"},{"type":"macro","title":"Patch.Assertions.assert_called/2","doc":"Given a call will assert that a matching call was observed exactly the number of times provided by the patched function. This macro fully supports patterns and will perform non-hygienic binding similar to ExUnit's assert_receive/3 and assert_received/2 . The value bound will be the from the latest call. patch ( Example , :function , :patch ) Example . function ( 1 , 2 , 3 ) Patch.Assertions . assert_called ( Example , :function , [ 1 , 2 , 3 ] , 1 ) # passes Patch.Assertions . assert_called ( Example , :function , [ 1 , _ , 3 ] , 1 ) # passes Example . function ( 1 , 2 , 3 ) Patch.Assertions . assert_called ( Example , :function , [ 1 , 2 , 3 ] , 2 ) # passes Patch.Assertions . assert_called ( Example , :function , [ 1 , _ , 3 ] , 2 ) # passes There is a convenience macro in the Developer Interface, Patch.assert_called/2 which should be preferred over calling this macro directly.","ref":"Patch.Assertions.html#assert_called/2"},{"type":"macro","title":"Patch.Assertions.assert_called_once/1","doc":"Given a call will assert that a matching call was observed exactly once by the patched function. This macro fully supports patterns and will perform non-hygienic binding similar to ExUnit's assert_receive/3 and assert_received/2 . patch ( Example , :function , :patch ) Example . function ( 1 , 2 , 3 ) Patch.Assertions . assert_called_once ( Example , :function , [ 1 , 2 , 3 ] ) # passes Patch.Assertions . assert_called_once ( Example , :function , [ 1 , _ , 3 ] ) # passes Example . function ( 1 , 2 , 3 ) Patch.Assertions . assert_called_once ( Example , :function , [ 1 , 2 , 3 ] ) # fails Patch.Assertions . assert_called_once ( Example , :function , [ 1 , _ , 3 ] ) # fails There is a convenience macro in the Developer Interface, Patch.assert_called_once/1 which should be preferred over calling this macro directly.","ref":"Patch.Assertions.html#assert_called_once/1"},{"type":"macro","title":"Patch.Assertions.format_patterns/1","doc":"Formats the AST for a list of patterns AST as they would appear in an argument list.","ref":"Patch.Assertions.html#format_patterns/1"},{"type":"function","title":"Patch.Assertions.refute_any_call/2","doc":"Refutes that the given module and function has been called with any arity. patch ( Example , :function , :patch ) Patch.Assertions . refute_any_call ( Example , :function ) # passes Example . function ( 1 , 2 , 3 ) Patch.Assertions . refute_any_call ( Example , :function ) # fails There are convenience delegates in the Developer Interface, Patch.refute_any_call/1 and Patch.refute_any_call/2 which should be preferred over calling this function directly.","ref":"Patch.Assertions.html#refute_any_call/2"},{"type":"macro","title":"Patch.Assertions.refute_called/1","doc":"Given a call will refute that a matching call was observed by the patched function. This macro fully supports patterns. patch ( Example , :function , :patch ) Example . function ( 1 , 2 , 3 ) Patch.Assertions . refute_called ( Example , :function , [ 4 , 5 , 6 ] ) # passes Patch.Assertions . refute_called ( Example , :function , [ 4 , _ , 6 ] ) # passes Patch.Assertions . refute_called ( Example , :function , [ 1 , 2 , 3 ] ) # fails Patch.Assertions . refute_called ( Example , :function , [ 1 , _ , 3 ] ) # passes There is a convenience macro in the Developer Interface, Patch.refute_called/1 which should be preferred over calling this macro directly.","ref":"Patch.Assertions.html#refute_called/1"},{"type":"macro","title":"Patch.Assertions.refute_called/2","doc":"Given a call will refute that a matching call was observed exactly the number of times provided by the patched function. This macro fully supports patterns. patch ( Example , :function , :patch ) Example . function ( 1 , 2 , 3 ) Patch.Assertions . refute_called ( Example , :function , [ 1 , 2 , 3 ] , 2 ) # passes Patch.Assertions . refute_called ( Example , :function , [ 1 , _ , 3 ] , 2 ) # passes Example . function ( 1 , 2 , 3 ) Patch.Assertions . refute_called ( Example , :function , [ 1 , 2 , 3 ] , 1 ) # passes Patch.Assertions . refute_called ( Example , :function , [ 1 , _ , 3 ] , 1 ) # passes There is a convenience macro in the Developer Interface, Patch.refute_called/2 which should be preferred over calling this macro directly.","ref":"Patch.Assertions.html#refute_called/2"},{"type":"macro","title":"Patch.Assertions.refute_called_once/1","doc":"Given a call will refute that a matching call was observed exactly once by the patched function. This macro fully supports patterns. patch ( Example , :function , :patch ) Example . function ( 1 , 2 , 3 ) Patch.Assertions . refute_called_once ( Example , :function , [ 1 , 2 , 3 ] ) # fails Patch.Assertions . refute_called_once ( Example , :function , [ 1 , _ , 3 ] ) # fails Example . function ( 1 , 2 , 3 ) Patch.Assertions . refute_called_once ( Example , :function , [ 1 , 2 , 3 ] ) # passes Patch.Assertions . refute_called_once ( Example , :function , [ 1 , _ , 3 ] ) # passes There is a convenience macro in the Developer Interface, Patch.refute_called_once/1 which should be preferred over calling this macro directly.","ref":"Patch.Assertions.html#refute_called_once/1"},{"type":"module","title":"Patch.Macro","doc":"","ref":"Patch.Macro.html"},{"type":"function","title":"Patch.Macro.debug/1","doc":"Utility function that acts like inspect/1 but prints out the Macro as code.","ref":"Patch.Macro.html#debug/1"},{"type":"macro","title":"Patch.Macro.match/2","doc":"Performs an non-hygienic match. If the match succeeds true is returned, otherwise a MatchError is raised. Since the match is non-hygienic pins can be used from the user-scope and binds will effect user-scope.","ref":"Patch.Macro.html#match/2"},{"type":"macro","title":"Patch.Macro.match?/2","doc":"Performs a match, return true if match matches, false otherwise.","ref":"Patch.Macro.html#match?/2"},{"type":"module","title":"Patch.Reflection","doc":"","ref":"Patch.Reflection.html"},{"type":"function","title":"Patch.Reflection.find_arities/2","doc":"","ref":"Patch.Reflection.html#find_arities/2"},{"type":"function","title":"Patch.Reflection.find_functions/1","doc":"","ref":"Patch.Reflection.html#find_functions/1"},{"type":"module","title":"Patch.Supervisor","doc":"","ref":"Patch.Supervisor.html"},{"type":"function","title":"Patch.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Patch.Supervisor.html#child_spec/1"},{"type":"function","title":"Patch.Supervisor.init/1","doc":"Callback implementation for Supervisor.init/1 .","ref":"Patch.Supervisor.html#init/1"},{"type":"function","title":"Patch.Supervisor.start_link/1","doc":"","ref":"Patch.Supervisor.html#start_link/1"},{"type":"exception","title":"Patch.ConfigurationError","doc":"","ref":"Patch.ConfigurationError.html"},{"type":"exception","title":"Patch.InvalidAnyCall","doc":"","ref":"Patch.InvalidAnyCall.html"},{"type":"exception","title":"Patch.MissingCall","doc":"","ref":"Patch.MissingCall.html"},{"type":"exception","title":"Patch.UnexpectedCall","doc":"","ref":"Patch.UnexpectedCall.html"},{"type":"extras","title":"Patch","doc":"Patch - Ergonomic Mocking for Elixir Patch makes it easy to replace functionality in tests with test specific functionality. Patch augments ExUnit with several utilities that make writing tests in Elixir fast and easy. Patch includes unique functionality that no other mocking library for Elixir provides, Patch's Super Powers .","ref":"readme.html"},{"type":"extras","title":"Patch - Features","doc":"Why use Patch instead of meck, Mock, Mockery, Mox, etc? Patch starts with a very simple idea for how a patched function should work. Patched functions should always return the mock value they are given. Here are the key features of Patch. Easy-to-use and composable interface with sensible defaults. First class support for working with Processes. No testing code in non-test code. In addition to these features which many libraries aspire to, Patch has 3 additional features that no other mocking library for Elixir / Erlang seem to have. These Super Powers are Patch mocks are effective for both local and remote calls. This means a patched function always resolves to the patch. Patch can patch private functions without changing their visibility. Patch makes it possible to test your private functions without changing their visibility via the expose/2 functionality. See the Mockompare companion project for a comparison of Elixir / Erlang mocking libraries. If there is a way to accomplish the following with another library, please open an issue so this section and the comparisons can be updated. For more information about Patch's Super Powers see the Super Powers Documentation","ref":"readme.html#features"},{"type":"extras","title":"Patch - Table of Contents","doc":"Installation Quickstart Core Functions Assertions Value Builders Customizing Imports Guide Book Support Matrix Limitations Prior Art Changelog","ref":"readme.html#table-of-contents"},{"type":"extras","title":"Patch - Installation","doc":"Add patch to your mix.exs def deps do [ { :patch , &quot;~&gt; 0.13.1&quot; , only : [ :test ] } ] end","ref":"readme.html#installation"},{"type":"extras","title":"Patch - Quickstart","doc":"After adding the dependency just add the following line to any test module after using your test case use Patch This library comes with a comprehensive suite of unit tests. These tests not only verify that the library is working correctly but are designed so that for every bit of functionality there is an easy to understand example for how to use that feature. Check out the User Tests for examples of how to use each feature. Using Patch adds 11 core functions, 10 assertions, 7 mock value builders, and 1 utility function to the test. These imports can be controlled, see the Customizing Imports for details. See the Cheatsheet for an overview of how the library can be used and as a handy reference. Continue below for links to more in-depth documentation including the Guidebook . Core Functions Core functions let us apply patches, patch processes, intercept messages, and query our patched modules. Core Function Description expose/2 Expose private functions as public for the purposes of testing fake/2 Replaces a module with a fake module history/1,2 Returns the call history for a mock inject/3,4 Injects a listener into a GenServer listen/3 Intercepts messages to a process and forwards them to the test process patch/3 Patches a function so that it returns a mock value private/1 Macro to call exposed private functions without raising a compiler warning real/1 Resolves the real module for a patched module replace/3 Replaces part of the state of a GenServer restore/1,2 Restores an entire module or just a function within a module to its pre-patched form spy/1 Patches a module so calls can be asserted without changing behavior Assertions Assertions make it easy to assert that a patched module has or has not observed a call. Assertion Description assert_any_call/1 Asserts that any call of any arity has occurred on the mocked module for a function name (preferred macro) assert_any_call/2 Asserts that any call of any arity has occurred on the mocked module for a function name (advanced use cases) assert_called/1 Asserts that a particular call has occurred on a mocked module assert_called/2 Asserts that a particular call has occurred a given number of times on a mocked module assert_called_once/1 Asserts that a particular call has occurred exactly once on a mocked module refute_any_call/1 Refutes that any call of any arity has occurred on the mocked module for a function name (preferred macro) refute_any_call/2 Refutes that any call of any arity has occurred on the mocked module for a function name (advanced use cases) refute_called/1 Refutes that a particular call has occurred on a mocked module refute_called/2 Refutes that a particular call has occurred a given number of time on a mocked module refute_called_once/1 Refutes that a particular call has occurred exactly once on a mocked module Value Builders Patched functions aren't limited to only returning simple scalar values, a host of Value Builders are provided for all kinds of testing scenarios. See the patch documentation for details. Value Builder Description callable/1,2 Callable that will be invoked on every patch invocation, dispatch and evaluation modes can be customized cycle/1 Cycles through the values provided on every invocation raises/1 Raises a RuntimeException with the given message upon invocation raises/2 Raises the specified Exception with the given attribtues upon invocation scalar/1 Returns the argument as a literal, useful for returning functions sequence/1 Returns the values in order, repeating the last value indefinitely throws/1 Throws the given value upon invocation Utility Functions Patch comes with some utilities that can assist when tests aren't behaving as expected. Utility Function Description debug/0,1 Enable or Disable debug mode for a given test Customizing Imports By default, Patch will import the functions listed in the previous sections. Imports can be customized through the :only , :except and :alias options. :only and :except work similiarly to how they work for the import except the values are either a list of symbol atoms or the special atom :all . Here's how only the expose , patch , and private symbols can be imported. use Patch , only : [ :expose , :patch , :private ] Here's how every symbol except throws can be imported use Patch , except : [ :throws ] Patch also allows you to alias imported symbols, to import patch as mock the following would be used. use Patch , alias : [ patch : :mock ]","ref":"readme.html#quickstart"},{"type":"extras","title":"Patch - Guide Book","doc":"Patch comes with plenty of documentation and a Suite of User Tests that show how to use the library. For a guided tour and deep dive of Patch, see the Guide Book","ref":"readme.html#guide-book"},{"type":"extras","title":"Patch - Support Matrix","doc":"Tests automatically run against a matrix of OTP and Elixir Versions, see the ci.yml for details. OTP \\ Elixir 1.7 1.8 1.9 1.10 1.11 1.12 1.13 1.14 1.15 1.16 20 ✅ ✅ ✅ N/A N/A N/A N/A N/A N/A N/A 21 ✅ ✅ ✅ ✅ ✅ N/A N/A N/A N/A N/A 22 ✅ ✅ ✅ ✅ ✅ ✅ ✅ N/A N/A N/A 23 N/A N/A N/A ✅ ✅ ✅ ✅ ✅ N/A N/A 24 N/A N/A N/A N/A ✅ ✅ ✅ ✅ ✅ N/A 25 N/A N/A N/A N/A N/A N/A ✅ ✅ ✅ ✅ 26 N/A N/A N/A N/A N/A N/A N/A ✅ ✅ ✅","ref":"readme.html#support-matrix"},{"type":"extras","title":"Patch - Limitations","doc":"Patch works by recompiling modules, this alters the global execution environment. Since the global execution environment is altered by Patch, Patch is not compatible with async: true .","ref":"readme.html#limitations"},{"type":"extras","title":"Patch - Prior Art","doc":"Up to version 0.5.0 Patch was based off the excellent meck library. Patch Super Powers required a custom replacement for meck, Patch.Mock . Patch also takes inspiration from python's unittest.mock.patch for API design.","ref":"readme.html#prior-art"},{"type":"extras","title":"Patch - Contributors","doc":"Patch is made better everyday by developers requesting new features. daisyzhou Suggested the new function pass through behavior introduced in v0.9.0 likeanocean Suggested assert_called/2 , assert_called_once/1 , refute_called/2 , and refute_called_once/1 introduced in v0.7.0 birarda Suggested assert_any_call/2 , refute_any_call/2 introduced in v0.2.0 Suggested listen/1 introduced in v0.13.0 to listen without a target. kianmeng Corrected several typographical errata Improved the ci.yml, brining it up to date with best practices. Dorgan Reported erratum in the Patch Cheatsheet Luca Corti Reported an issue with warning being emitted by the library on Elixir 1.16 which served as the basis for a bugfix in v0.13.1 If you have a suggestion for improvements to this library, please open an issue.","ref":"readme.html#contributors"},{"type":"extras","title":"Patch - Changelog","doc":"See the Changelog","ref":"readme.html#changelog"},{"type":"extras","title":"Cheatsheet","doc":"This cheatsheet provides simple examples for how to use Patch, for more details see the linked documentation.","ref":"cheatsheet.html"},{"type":"extras","title":"Cheatsheet - Installation","doc":"Add Patch to your Dependencies In the deps/0 function in the mix.exs file add a line for Patch. mix.exs def deps do [ { :patch , &quot;~&gt; 0.12.0&quot; , only : [ :test ] } ] end Optionally Including / Excluding Imports :only will cause only a subset of symbols to be imported test/example_only_test.exs defmodule ExampleOnlyTest do use ExUnit.Case use Patch , only : [ :expose , :patch , :private ] # ... snip the rest of the module ... end :except will import all symbols except the ones specified test/example_except_test.exs defmodule ExampleExceptTest do use ExUnit.Case use Patch , except : [ :fake , :history ] # ... snip the rest of the module ... end Use Patch in your Test Case In any ExUnit.Case based Test Case add a line to use Patch. test/example_test.exs defmodule ExampleTest do use ExUnit.Case use Patch # ... snip the rest of the module ... end Aliasing Imports :alias allows the test author to import a symbol while renaming it. test/example_alias_test.exs defmodule ExampleAliasTest do use ExUnit.Case use Patch , alias : [ patch : :mock ] # ... snip the rest of the module ... end","ref":"cheatsheet.html#installation"},{"type":"extras","title":"Cheatsheet - Patching","doc":"Scalars test &quot;can patch with scalar values&quot; do assert String . upcase ( &quot;Pre-Patched&quot; ) == &quot;PRE-PATCHED&quot; patch ( String , :upcase , &quot;PATCHED&quot; ) assert String . upcase ( &quot;Post-Patched&quot; ) == &quot;PATCHED&quot; end Callables test &quot;can patch with a callable&quot; do assert String . upcase ( &quot;Pre-Patched&quot; ) == &quot;PRE-PATCHED&quot; patch ( String , :upcase , fn s -&gt; String . length ( s ) end ) assert String . upcase ( &quot;Post-Patched&quot; ) == 12 end Cycles test &quot;can patch with a cycle&quot; do assert String . upcase ( &quot;Pre-Patched&quot; ) == &quot;PRE-PATCHED&quot; patch ( String , :upcase , cycle ( [ 1 , 2 , 3 ] ) ) assert String . upcase ( &quot;Post-Patched&quot; ) == 1 assert String . upcase ( &quot;Post-Patched&quot; ) == 2 assert String . upcase ( &quot;Post-Patched&quot; ) == 3 assert String . upcase ( &quot;Post-Patched&quot; ) == 1 assert String . upcase ( &quot;Post-Patched&quot; ) == 2 end Sequences test &quot;can patch with a sequence&quot; do assert String . upcase ( &quot;Pre-Patched&quot; ) == &quot;PRE-PATCHED&quot; patch ( String , :upcase , sequence ( [ 1 , 2 , 3 ] ) ) assert String . upcase ( &quot;Post-Patched&quot; ) == 1 assert String . upcase ( &quot;Post-Patched&quot; ) == 2 assert String . upcase ( &quot;Post-Patched&quot; ) == 3 assert String . upcase ( &quot;Post-Patched&quot; ) == 3 assert String . upcase ( &quot;Post-Patched&quot; ) == 3 end Raises test &quot;can patch to raise a RuntimeError&quot; do assert String . upcase ( &quot;Pre-Patched&quot; ) == &quot;PRE-PATCHED&quot; patch ( String , :upcase , raises ( &quot;patched&quot; ) ) assert_raise RuntimeError , &quot;patched&quot; , fn -&gt; String . upcase ( &quot;Post-Patched&quot; ) end end test &quot;can patch to raise any exception&quot; do assert String . upcase ( &quot;Pre-Patched&quot; ) == &quot;PRE-PATCHED&quot; patch ( String , :upcase , raises ( ArgumentError , message : &quot;patched&quot; ) ) assert_raise ArgumentError , &quot;patched&quot; , fn -&gt; String . upcase ( &quot;Post-Patched&quot; ) end end Throws test &quot;can patch to throw a value&quot; do assert String . upcase ( &quot;Pre-Patched&quot; ) == &quot;PRE-PATCHED&quot; patch ( String , :upcase , throws ( :patched ) ) assert catch_throw ( String . upcase ( &quot;Post-Patched&quot; ) ) == :patched end","ref":"cheatsheet.html#patching"},{"type":"extras","title":"Cheatsheet - Assertions","doc":"assert_called test &quot;can assert calls on patched functions&quot; do assert String . upcase ( &quot;Pre-Patched&quot; ) == &quot;PRE-PATCHED&quot; patch ( String , :upcase , &quot;PATCHED&quot; ) assert String . upcase ( &quot;Post-Patched&quot; ) == &quot;PATCHED&quot; assert_called String . upcase ( &quot;Post-Patched&quot; ) ## Arguments can be bound or pattern-matched assert_called String . upcase ( argument ) assert argument == &quot;Post-Patched&quot; ## The number of calls can be specified assert_called String . upcase ( &quot;Post-Patched&quot; ) , 1 end refute_called test &quot;can refute calls on patched functions&quot; do assert String . upcase ( &quot;Pre-Patched&quot; ) == &quot;PRE-PATCHED&quot; patch ( String , :upcase , &quot;PATCHED&quot; ) assert String . upcase ( &quot;Post-Patched&quot; ) == &quot;PATCHED&quot; refute_called String . upcase ( &quot;Other&quot; ) end assert_any_call test &quot;can assert that a patched function was called with any arity&quot; do assert String . upcase ( &quot;Pre-Patched&quot; ) == &quot;PRE-PATCHED&quot; patch ( String , :upcase , &quot;PATCHED&quot; ) assert String . upcase ( &quot;Post-Patched&quot; ) == &quot;PATCHED&quot; assert_any_call String , :upcase end refute_any_call test &quot;can refute that a patched function was called with any arity&quot; do assert String . upcase ( &quot;Pre-Patched&quot; ) == &quot;PRE-PATCHED&quot; patch ( String , :upcase , &quot;PATCHED&quot; ) refute_any_call String , :upcase end spy test &quot;can assert / refute calls on spied modules without changing behavior&quot; do spy ( String ) assert String . upcase ( &quot;Example&quot; ) == &quot;EXAMPLE&quot; assert_called String . upcase ( &quot;Example&quot; ) refute_called String . upcase ( &quot;Other&quot; ) end history test &quot;can retrieve the list of all calls to a patched module&quot; do spy ( String ) assert String . upcase ( &quot;Example&quot; ) == &quot;EXAMPLE&quot; assert String . downcase ( &quot;Example&quot; ) == &quot;example&quot; assert history ( String ) == [ { :upcase , [ &quot;Example&quot; ] } , { :downcase , [ &quot;Example&quot; ] } ] assert history ( String , :asc ) == [ { :upcase , [ &quot;Example&quot; ] } , { :downcase , [ &quot;Example&quot; ] } ] assert history ( String , :desc ) == [ { :downcase , [ &quot;Example&quot; ] } , { :upcase , [ &quot;Example&quot; ] } ] end","ref":"cheatsheet.html#assertions"},{"type":"extras","title":"Cheatsheet - Private Functions","doc":"expose test &quot;can expose private functions for testing&quot; do expose ( Example , private_function : 1 ) assert Example . private_function ( :argument ) == { :ok , :argument } end private test &quot;can suppress warnings about calling private functions&quot; do expose ( Example , private_function : 1 ) assert private ( Example . private_function ( :argument ) ) == { :ok , :argument } end","ref":"cheatsheet.html#private-functions"},{"type":"extras","title":"Cheatsheet - Processes","doc":"listen test &quot;can listen to the messages sent to a named process&quot; do listen ( :tag , ExampleNamedProcess ) send ( ExampleNamedProcess , :hello ) assert_receive { :tag , :hello } end test &quot;can listen to the messages sent to a pid&quot; do pid = Example . start_link ( ) listen ( :tag , pid ) send ( pid , :hello ) assert_receive { :tag , :hello } end test &quot;can listen to GenServer messages&quot; do Counter . start_link ( 0 , name : Counter ) listen ( :tag , Counter ) assert Counter . increment ( ) == 1 assert_receive { :tag , { GenServer , :call , :increment , from } } # Bind `from` assert_receive { :tag , { GenServer , :reply , 1 , ^ from } } # Match the pinned `from` end inject test &quot;listeners can be injected into another processes state&quot; do { :ok , parent_pid } = Parent . start_link ( ) inject ( :tag , parent_pid , [ :child_pid ] ) assert Parent . ask_child ( ) == :ok assert_recieve { :tag , :ask } end replace test &quot;process state can be replaced by key&quot; do { :ok , pid } = Example . start_link ( ) assert :sys . get_state ( pid ) . field == :original replace ( pid , [ :field ] , :updated ) assert :sys . get_state ( pid ) . field == :updated end","ref":"cheatsheet.html#processes"},{"type":"extras","title":"Super Powers","doc":"Patch provides unique features that no other mocking library for Elixir offers. See the Mockompare suite for a comparison of Elixir / Erlang mocking libraries. If there is a way to accomplish the following with another library, please open an issue so this section and the comparisons can be updated. So what are these super powers? Patch mocks are effective for both local and remote calls. This means a patched function always resolves to the patch. Patch can patch private functions without changing their visibility. Patch makes it possible to test your private functions without changing their visibility via the expose/2 functionality.","ref":"super-powers.html"},{"type":"extras","title":"Super Powers - Local and Remote Calls","doc":"In Elixir we have two different ways to call a function, local call vs remote call. In a local call, the module is not specified. defmodule Example do def example do collaborator ( ) # No Module, this is a local call end def collaborator do :original end end In a remote call the module is specified, this is most common when calling from one module to another, but can be done within a module if desired. defmodule Example do def example do __MODULE__ . collaborator ( ) # Module specified, this is a remote call end def collaborator do :original end end It is exceedingly common to use local calls when writing a module. The problem comes when mocking a collaborator function. First, why might we want to mock out a collaborator? Here's an example where we might want to skip some functionality. defmodule Example do def save ( thing ) do if valid? ( thing ) do do_save ( thing ) else { :error , :invalid } end end def valid? ( thing ) do [ &amp; Example.Validation . name_not_blank? / 1 , &amp; Example.Validation . token_hash_valid? / 1 , &amp; Example.Validation . flux_capacitor_within_limits? / 1 ] |&gt; Enum . all? ( fn validator -&gt; validator . ( thing ) end ) end defp do_save ( thing ) do DB . insert ( thing ) end end In the unit tests for Example.save/1 we want to test the high level logic of &quot;valid gets saved, invalid gets an error.&quot; This is complicated though because Example.valid?/1 has real validations baked in. A common approach is to create a fixture that can pass the validation rules and one that can't. This is a brittle solution though, it introduces a high degree of coupling between the Example.save/1 tests and the implementation of Example.valid?/1 . A more robust approach is simply to patch out the call to Example.valid?/1 . When we want to test that a valid thing gets saved, we don't have to jump through hoops to get Example.valid?/1 to return true, we can just patch it and tell it to return true. When someone comes along and changes the validation rules in Example.valid?/1 it won't break our Example.save/1 tests, it might break the tests for Example.valid?/1 but that's a much better outcome because the test breaking is directly related to the code being changed. Additionally, in a unit test we would want to isolate the unit from the database. Our Example.do_save/1 method wants to actually write to a database, but this is an implementation detail as far as Example.save/1 is concerned. A common approach in unit testing is to replace external dependencies, like APIs and Databases, with Fakes. A Fake DB could be as complex another copy of the schema actually running on the real database software that's isolated for test data or as simple as an in memory map. In this style of testing, the test author can let the code read and write from the fake datastore and then query to make sure the datastore is in the appropriate state. This approach &quot;over tests&quot; the datastore, which is likely already well tested. A simpler approach is to simply patch out Example.do_save/1 since we only care that it gets called and it's correct functioning should be guaranteed by tests that directly test that function. With Patch, we can mock these functions and have the mocks be effective even though the module is using the common local call pattern. defmodule ExampleTest do use ExUnit.Case use Patch describe &quot;save/1&quot; do test &quot;valid things will be saved&quot; do # Make everything valid patch ( Example , :valid? , true ) # Patch out do_save so we don&#39;t try to hit the database patch ( Example , :do_save , :ok ) assert :ok == Example . save ( :thing ) assert_called Example . do_save ( :thing ) end test &quot;invalid things will not be saved&quot; do # We want to refute the call to do_save/1, so let&#39;s spy the entire module spy ( Example ) # Make everything invalid patch ( Example , :valid? , false ) assert { :error , :invalid } == Example . save ( :thing ) refute_called Example . do_save ( _ ) end end end","ref":"super-powers.html#local-and-remote-calls"},{"type":"extras","title":"Super Powers - Patching Private Functions","doc":"Patch allows the test author to patch private functions without doing anything special. Given the following module defmodule Example do def public_function ( a ) do { :ok , private_function ( a ) } end defp private_function ( a ) do { :private , a } end end We can write the following test. defmodule ExampleTest do use ExUnit.Case use Patch test &quot;public_function/1 wraps private_function/1&quot; do patch ( Example , :private_function , :patched ) assert Example . public_function ( :test_argument ) == { :ok , :patched } end end Since Patch guarantees that all calls to a patched function return the mock value, this works as expected. Private functions can be patched just like a public function, but unless they are exposed via expose/2 they don't become public. This means that any other code in the project that might have mistakenly made a call to Example.private_function/1 will fail under test because the visibility is still private. To make a private function public, read on to the next section.","ref":"super-powers.html#patching-private-functions"},{"type":"extras","title":"Super Powers - Testing Private Functions","doc":"Private functions frequently go untested because they are difficult to test. Developers are faced with a few options when they have a private function. Don't test the private function. Test the private function circuitously by calling some public functions. Make a public wrapper for the private function and test that. Change the visibility to public and put a comment with some form of, &quot;This is public just for testing, this function should be treated as though it's private.&quot; Patch provides a new mechanism for testing private functions, expose/2 . With expose/2 the test author can expose any private function to the tests as though it's public. Here's an example. defmodule Example do def public_function ( arg ) do value = private_function ( arg ) if value &lt; 100 do :small else :large end end ## Private defp private_function ( arg ) when arg &lt; 20 do arg * 1000 end defp private_function ( arg ) when arg &lt; 80 do arg - 3 end defp private_function ( arg ) do Integer . floor_div ( arg , 2 ) end end Testing public_function/1 gives us a very coarse measure of if the private_function/1 logic is working correctly. It would be great if we could expose private_function/1 to be able to more directly test this unit. Here's how we can expose this function for testing via expose/2 . Calling an exposed functions will be flagged by the Elixir Compiler as a warning, since the exposure happens at runtime not compile-time. To suppress these warnings, the private/1 macro is provided, just wrap the call to the exposed function with private/1 . defmodule ExampleTest do use ExUnit.Case use Patch describe &quot;private_function/1&quot; do test &quot;values less than 20 get magnified by 1000&quot; do expose ( Example , private_function : 1 ) assert private ( Example . private_function ( 10 ) ) == 10_000 end test &quot;values between 20 and 80 are reduced by 3&quot; do expose ( Example , private_function : 1 ) assert private ( Example . private_function ( 50 ) ) == 47 end test &quot;values greater than or equal to 80 are halved&quot; do expose ( Example , private_function : 1 ) assert private ( Example . private_function ( 120 ) ) == 60 end end end","ref":"super-powers.html#testing-private-functions"},{"type":"extras","title":"Super Powers - How does this all work?","doc":"Check out the documentation for Patch.Mock.Code for more details on how this is accomplished.","ref":"super-powers.html#how-does-this-all-work"},{"type":"extras","title":"Change Log","doc":"","ref":"changelog.html"},{"type":"extras","title":"Change Log - 0.14.0 (2024-10-15)","doc":"Changes where mocks are evaluated to prevent misuse and allow for common patterns that were not previously supported. Pre-0.14.0 mocks would be intercepted by the Patch.Mock.Server and the mock value would be calculated by the server. This works for most cases, but has surprising behavior when the mock function cares about the process executing the function. Consider the following example. defmodule ExampleTest do use ExUnit.Case use Patch test &quot;example&quot; do patch ( Example , :get_pid , fn -&gt; self ( ) end ) assert Example . get_pid ( ) == self ( ) end end This would fail in pre-0.14.0 because the fn -&gt; self() end would be executed by the Patch.Mock.Server and the pid returned would be the pid for the Patch.Mock.Server and not the caller's pid as the test author might expect. 0.14.0 changes this behavior and now will execute the fn -&gt; self() end in the caller and return the expected result. This also makes it much more difficult to address the Patch.Mock.Server directly, which is generally discouraged as this server is an implementation detail and should only be addressed by the Patch code itself. This should prevent a class of errors and confusing bugs caused by tests accidentally capturing the pid of, monitoring, or linking to the Patch.Mock.Server Improvements ⬆️ - [Internal] Mocks are now evaluated in the caller process instead of the Patch.Mock.Server process, see above for details. Breaking Changes 💔 - Mocks are now evaluated in the caller process instead of the Patch.Mock.Server process. Using the Patch.Mock.Server pid or interacting with the process is not advised but if your tests relied on being able to do this they may break due to this change.","ref":"changelog.html#0-14-0-2024-10-15"},{"type":"extras","title":"Change Log - 0.13.1 (2024-05-02)","doc":"Minor bugfix to correct an issue with negative step ranges in String.slice/2 raised by Josephine Hissssst Luca Corti Bugfixes 🐞 - Fixed a warning raised from using a range with a negative step in String.slice/2","ref":"changelog.html#0-13-1-2024-05-02"},{"type":"extras","title":"Change Log - 0.13.0 (2023-10-17)","doc":"Added the ability to control how Patch functions are imported in test modules. Added the ability to listen/3 without a target, useful when a process is spawned by another process and the spawning of that process is not within the testing boundaries. Features 🎁 - listen/1 can now be used to construct a listener without a target. 🎁 - inject/4 can now be used to inject a listener without a target. 🎁 - use Patch now accepts :alias , :only , and :except to control exactly which Patch helpers are being pulled in and how they will be named. Breaking Changes None","ref":"changelog.html#0-13-0-2023-10-17"},{"type":"extras","title":"Change Log - 0.12.0 (2022-02-08)","doc":"Fixed a bug where defective mock functions would be incorrectly classified as unmocked functions, this would engage the passthrough functionality and call the original function. If a passthrough mock function's implementation raised BadArityError or FunctionClauseError it would be incorrectly classified by the mock system as an unmocked function. The internal mechanisms have been updated to differentiate between exceptions arising directly from the function call vs exceptions in caused by executing the code in the function. Added a new debug/0,1 facility that can be used to enable library level debugging in for a test function. This functionality can also be controlled by the :patch :debug configuration value. Features 🎁 - debug/0,1 has been added. By default it will enable debugging for the test it is invoked in. If debugging has been enabled suite wide via the :patch :debug configuration value, then debug/1 can be used with the argument false to disable testing for the test it is invoked in. Bugfixes 🐞 - Fixed the issue where defective mocks would cause the mock system to call the original function. Improvements ⬆️ - [CI] Updated CI tests from 1.12.2 to 1.12.3 and added 1.13.2 tests to the compatibility matrix. Breaking Changes None","ref":"changelog.html#0-12-0-2022-02-08"},{"type":"extras","title":"Change Log - 0.11.0 (2022-01-21)","doc":"New private/2 macro to assist with using exposed functions. Introduces &quot;Tagged Histories&quot; to prevent a race condition that causes confusing output when using Patch assertions. Race Condition Description: Assertion function checks the history for a matching call, none is found. Assertion function pulls the history to format an error message. Between 1 and 2 if a matching call arrived then the assertion would fail but print out a message with a matching call. This race condition has been defeated by only pulling the history once and using it for both checking for the existence of a call and formatting an error message. In addition a bunch of code that was littering Patch.Mock has been moved to a more appropriate location by introducing the concept of a &quot;Tagged History&quot; (Patch.Mock.History.Tagged) Tagged Histories have the same entries as a History. One generates a Tagged History from a History and some matching criteria. Ever entry in the Tagged History is the entry from the History tagged with a boolean that indicates whether or not it matched the construction criteria. Features 🎁 - private/2 has been added, it's similar to private/1 but allows the test author to pipe a value into private/2 and have it end up in the call that's being wrapped. Bugfixes 🐞 - Fixed the behavior of Patch Assertion functions to prevent the race condition described above. Breaking Changes None","ref":"changelog.html#0-11-0-2022-01-21"},{"type":"extras","title":"Change Log - 0.10.2 (2022-01-20)","doc":"Major fix to Patch.Mock.Code.Transforms.Remote . Previously this transform completely ignored remote calls. This would cause an issue when one of the arguments to the remote call was itself a local call. This has been corrected and the Patch.Test.User.Patch.LocalCallTest was updated to prevent regressions. Bugfixes 🐞 - Fixed the Patch.Mock.Code.Transforms.Remote transformer to correctly handle the arguments of a Remote Call.","ref":"changelog.html#0-10-2-2022-01-20"},{"type":"extras","title":"Change Log - 0.10.1 (2021-12-07)","doc":"Minor fix to .formatter.exs . Exported format options were not being honored because of a typo, export is the honored key but exports was being used. Improvements ⬆️ - [Change Log] Removed sections that have no content, except for Breaking Changes . Sections will only be included in the Change Log if some change has actually occurred. To aid developers upgrading where between versions where breaking changes are allowed, Breaking Changes will be included when there are no breaking changes with the description None to clearly indicate that no breaking changes have occurred. Bugfixes 🐞 - Fixed the .formatter.exs so assertion functions won't be parenthesized by projects using import_deps","ref":"changelog.html#0-10-1-2021-12-07"},{"type":"extras","title":"Change Log - 0.10.0 (2021-12-05)","doc":"Changes how function patches work by introducing &quot;Stacked Callables.&quot; Stacked Callables are a large new feature that builds on the passthrough evaluation feature introduced in v0.9.0. Chapter 2 of the Guidebook has a new section that explains this design in detail. Breaking Changes 💔 - Subsequent calls to patch a function with a callable result in the callables stacking. This may break some tests if the tests rely on one callable completely replacing the previous callable. Use restore/2 to clear the manually clear the previous callable. Improvements ⬆️ - Stacked Callables provide a more ergonomic way to deal with multiple arities than the previous solution of using :list dispatch. See Stacking and Multiple Arities ⬆️ - Stacked Callables provide a more composable way to deal with multiple patches that rely on pattern matching. See Stacking and Matching ⬆️ - callable/2 now allows the caller to configured both the dispatch mode and the evaluation mode. This provides a cleaner upgrade path for anyone impacted by the breaking change introduced in v0.9.0. Using evaluate: :strict on a callable will make the callable act like a pre-v0.9.0 callable. Features 🎁 - restore/2 has been added, it's similar to restore/1 but allows the test author to restore a function in a module instead of the entire module. 🎁 - callable/2 has a new clause that accepts a Keyword.t of options. Supports dispatch which has the current dispatch modes ( :apply , the default, or :list ) as well as a new option evaluate which accepts either :passthrough (the default) or :strict . Strict evaluation behaves like pre-v0.9.0 Deprecations ⚠️ - callable/2 will still accept an atom as the second argument. When it is provided it will be used as the dispatch mode and the evaluate mode will be set to passthrough (the default). This is a candidate for removal in future versions.","ref":"changelog.html#0-10-0-2021-12-05"},{"type":"extras","title":"Change Log - 0.9.0 (2021-12-02)","doc":"Changes how function patches work so that the test author can only patch out a subset of function calls. Breaking Changes 💔 - When patching a function, calls that fail to match the patched function's clauses will passthrough to the original code. Tests that relied on the old behavior should add a catch-all clause. Improvements ⬆️ - Improved experience when working with complex functions. Consider a callback function like GenServer.handle_call/3 , a test author may wish to only patch out certain messages, allowing other messages to pass through to the original code. This is now supported, when a patched function fails to match because of either BadArityError or FunctionClauseError the original code will be called instead.","ref":"changelog.html#0-9-0-2021-12-02"},{"type":"extras","title":"Change Log - 0.8.2 (2021-11-12)","doc":"Bugfix for handling module attributes in Call Assertions. Bugfixes 🐞 - Fix in Patch.Macro to properly handle module attributes when matching.","ref":"changelog.html#0-8-2-2021-11-12"},{"type":"extras","title":"Change Log - 0.8.1 (2021-11-12)","doc":"Bugfix for handling modules with aggregate compile attributes. This fixes a codegen bug introduced in 0.8.0. Bugfixes 🐞 - Fix in Patch.Mock.Code.Transforms.Clean to properly handle aggregate compile attributes.","ref":"changelog.html#0-8-1-2021-11-12"},{"type":"extras","title":"Change Log - 0.8.0 (2021-11-11)","doc":"Improved call assertion to use full pattern matching. Pattern matching works like ExUnit's assert_receive/3 and assert_received/2 . Unpinned variables will be bound when asserting. Breaking Changes 💔 - Matching has been improved to use full pattern semantics. Call matching that uses :_ should be updated to _ . Call assertions can now use the full range of Elixir pattern matching. 💔 - inject/3 has been renamed to replace/3 Improvements ⬆️ - Call Assertions now support full pattern matching. ⬆️ - [Internal] Code Freezer for freezing the modules that Patch uses so test authors can patch modules Patch relies on without breaking the library. Features 🎁 - Renamed inject/3 to replace/3 which better conveys its functionality 🎁 - Added inject/4 which injects a listener into a running process. Bugfixes 🐞 - Code Freezer fixes a bug where patching GenServer caused Patch to deadlock. Removals ⛔️ - inject/3 was removed and renamed to replace/3","ref":"changelog.html#0-8-0-2021-11-11"},{"type":"extras","title":"Change Log - 0.7.0 (2021-10-21)","doc":"Support for call counts in assertions. assert_called/1 and refute_called/1 are unchanged. Breaking Changes None Improvements ⬆️ - Exception messages have been improved to clearly indicate which calls have matched. ⬆️ - Assertion Macros have been refactored to minimize injected code in line with Elixir best practices. Macros now defer to Patch.Assertions ⬆️ - Increased test coverage for assertions including improved message formatting. Features 🎁 - Added the assert_any_call/1 macro. This is now the preferred over assert_any_call/2 , it allows the test author to write assert_any_call Module.function instead of assert_any_call Module, :function 🎁 - Added the assert_called/2 assertion. The second argument is a call count, this assertion will only pass if there is exactly call count matching calls. 🎁 - Added the assert_called_once/1 assertion. This assertion only passes if there is one and only one matching call. 🎁 - Added the refute_any_call/1 macro. This is now preferred over refute_any_call/2 , it allows the test author to write refute_any_call Module.function instead of refute_any_call Module, :function 🎁 - Added the refute_called/2 assertion. The second argument is a call count, this assertion will pass as long as the number of matching calls does not equal the provided call count. 🎁 - Added the refute_called_once/1 assertion. This assertion will pass if there are any number of matching calls besides 1. Deprecations ⚠️ - Soft Deprecation for assert_any_call/2 . This function is not slated for removal but should be reserved for advanced use cases. Test authors should prefer assert_any_call/1 when possible. ⚠️ - Soft Deprecation for refute_any_call/2 . This function is not slated for removal but should be reserved for advanced use cases. Test authors should prefer refute_any_call/1 when possible.","ref":"changelog.html#0-7-0-2021-10-21"},{"type":"extras","title":"Change Log - 0.6.1 (2021-10-17)","doc":"Minor release to improve the documentation and reduce the scope of imported symbols from Patch.Mock.Value . Improvements ⬆️ - [Documentation] Guide Book broken into Chapters, additional information about core concepts. Removals ⛔️ - Patch.Mock.Value.advance/1 and Patch.Mock.Value.next/2 used to be imported into the test when use Patch was present. This was an oversight and these two functions are not meant to be called directly by the test author, the imports have been reduced to remove these symbols.","ref":"changelog.html#0-6-1-2021-10-17"},{"type":"extras","title":"Change Log - 0.6.0 (2021-10-16)","doc":"Major internal refactor. This version removes meck as a dependency and implements a Patch specific replacement, Patch.Mock . This allows us to have a new set of functionality that no other mocking library for Elixir / Erlang has today. Patch Mocks can now be said to obey a single simple rule, public or private, local or remote. A patched function always returns the mock value to all callers. Two new bits of functionality make this true. All calls, local or remote, end up intercepted and the mock value returned. Private functions can be mocked. And as a bonus Private functions can be converted into public functions for direct testing. Breaking Changes 💔 - Matching semantics have changed since meck is no longer the matching engine. Matching is now literal instead of pseudo-matching, upgrade to version 0.8.0+ for improved matching. Improvements ⬆️ - [Internal] Patch.Mock introduced to replace meck ⬆️ - [Documentation] README revamped again, new Super Powers documentation and Guide Book. Features 🎁 - Added the expose/2 function to support testing private functions. 🎁 - Added the history/1,2 function so the history of calls to a mock can be retrieved. 🎁 - Added the private/1 macro to prevent compiler warnings when calling private functions. 🎁 - Added the callable/1,2 value builder to create explicit callable mock values. 🎁 - Added the cycle/1 value builder to create a cycle mock values. 🎁 - Added the raises/1 value builder to cause a mocked function to raise a RuntimeError. 🎁 - Added the raises/2 value builder to cause a mocked function to raise any other Exception. 🎁 - Added the scalar/1 value builder to create explicit scalar mock values. 🎁 - Added the sequence/1 value builder to create sequence mock values. 🎁 - Added the throws/1 value builder to cause a mocked function to throw a value. Removals ⛔️ - [Dependency] meck was removed as a dependency","ref":"changelog.html#0-6-0-2021-10-16"},{"type":"extras","title":"Change Log - 0.5.0 (2021-09-17)","doc":"Better support for mocking erlang modules Breaking Changes None Improvements ⬆️ - [Internal] patch.release task to simplify releasing new versions of the library ⬆️ - Support for mocking erlang modules (both sticky and non-sticky) Bugfixes 🐞 - Mocking erlang modules actually works now","ref":"changelog.html#0-5-0-2021-09-17"},{"type":"extras","title":"Change Log - 0.4.0 (2021-08-09)","doc":"Support for working with Processes Breaking Changes None Improvements ⬆️ - [Testing] Testing Matrix updated to latest versions of Elixir / OTP ⬆️ - [Dependencies] meck updated to 0.9.2 ⬆️ - [Documentation] README revamped Features 🎁 - Added the listen/3 function to support listening to a process's messages 🎁 - Added the inject/3 function to support updating the state of a running process.","ref":"changelog.html#0-4-0-2021-08-09"},{"type":"extras","title":"Change Log - 0.3.0 (2021-07-12)","doc":"Support for replacing a module wholesale via the fake/2 function Breaking Changes None Improvements ⬆️ - [Internal] Patch.Function.for_arity/2 now accepts an anonymous function it will call instead of a term to return. ⬆️ - [Internal] Patch.find_functions/1 and Patch.find_arities/2 use __info__/1 now instead of doing 256 function_exported? checks per function. Features 🎁 - Added the fake/2 function to add support for module fakes. 🎁 - Added the real/1 function so module fakes can call the real module.","ref":"changelog.html#0-3-0-2021-07-12"},{"type":"extras","title":"Change Log - 0.2.0 (2021-03-03)","doc":"Removed Arity Limitations Breaking Changes None Improvements ⬆️ - Removed the arity limitation, can now patch functions of any arity Features 🎁 - Added the assert_any_call/2 and refute_any_call/2 assertion functions","ref":"changelog.html#0-2-0-2021-03-03"},{"type":"extras","title":"Change Log - 0.1.2 (2021-01-28)","doc":"Increased Elixir Compatibility Improvements ⬆️ - Relaxed Elixir version requirement down to 1.7","ref":"changelog.html#0-1-2-2021-01-28"},{"type":"extras","title":"Change Log - 0.1.1 (2020-04-27)","doc":"Bugfix Release Improvements ⬆️ - Made the library actually work Bugfixes 🐞 - Bugfix to make the library actually work","ref":"changelog.html#0-1-1-2020-04-27"},{"type":"extras","title":"Change Log - 0.1.0 (2020-04-21)","doc":"Initial Release Breaking Changes None Improvements ⬆️ - Patch released to the world. Easy to use and ergonomic Mocking for Elixir. Features 🎁 - patch/3 allows the patching of a module's function with a function. 🎁 - patch/3 allows the patching of a module's function with a static return value. 🎁 - spy/1 allows spying on a module. 🎁 - restore/1 allows removing patches and spies from a module. 🎁 - assert_called/1 allows for asserting that a patched or spied function has been called with the expected pattern of arguments. 🎁 - refute_called/1 allows for refuting that a patched or spied function has been called with the expected pattern of arguments.","ref":"changelog.html#0-1-0-2020-04-21"},{"type":"extras","title":"Chapter 1: Introduction","doc":"This guide book will walk you through using all the features and functionality of Patch to make great unit tests.","ref":"01-introduction.html"},{"type":"extras","title":"Chapter 1: Introduction - One Big Idea","doc":"Patch is founded on One Big Idea Patched functions should always return the mock value they are given. This is how patched functions behave in Patch . Every function is a valid target for patching and once patched the function will always return the mock value given. If you ever feel lost, remember this One Big Idea.","ref":"01-introduction.html#one-big-idea"},{"type":"extras","title":"Chapter 1: Introduction - Terminology","doc":"Throughout this guide book we are going to use some common terminology, let's define them. Patch Patch is used as both a verb and a noun. To &quot;patch&quot; a function is to replace it with an alternative implementation. The alternative implementation is the noun form of &quot;patch&quot; sometimes called the &quot;patched function.&quot; patch ( Example , :example , :patched ) Example.example has been &quot;patched&quot; with a &quot;patch&quot; that always returns the value :patched Mock Value The value returned by a &quot;patch&quot; is referred to as the &quot;mock value&quot;. There are a number of types of &quot;mock values&quot; that will be covered in detail in this guide book. Observed Call After a module has been patched, the calls to the module can be observed by Patch . Patch comes with utilities to assert or refute that certain calls have been observed. Calls that happen before the module has been patched are unobserved, the test author can not assert or refute anything about the calls to a module before it has been patched.","ref":"01-introduction.html#terminology"},{"type":"extras","title":"Chapter 2: Patching","doc":"The most common operation a test author will perform with Patch is, unsurprisingly, patching things. When a module is patched, the patched function will return the mock value provided.","ref":"02-patching.html"},{"type":"extras","title":"Chapter 2: Patching - Scalar Values","doc":"The simplest kind of patch is one that just returns a static scalar value on every invocation. defmodule PatchExample do use ExUnit.Case use Patch test &quot;functions can be patched to return a specified value&quot; do # Assertion passes before patching assert &quot;HELLO&quot; == String . upcase ( &quot;hello&quot; ) # The function can be patched to return a static scalar value patch ( String , :upcase , :patched ) # Assertion passes after patching assert :patched == String . upcase ( &quot;hello&quot; ) end end No matter how many times we call String.upcase/1 from here on in and no matter what arguments we pass, we will always get back the value :patched .","ref":"02-patching.html#scalar-values"},{"type":"extras","title":"Chapter 2: Patching - Callable Values","doc":"Modules can also be patched to run custom logic instead of returning a static value defmodule PatchExample do use ExUnit.Case use Patch test &quot;functions can be patched with a replacement function&quot; do # Assertion passes before patching assert &quot;HELLO&quot; == String . upcase ( &quot;hello&quot; ) # The function can be patched to run custom code patch ( String , :upcase , fn s -&gt; String . length ( s ) end ) # Assertion passes after patching assert 5 == String . upcase ( &quot;hello&quot; ) end end Every time we call String.upcase/1 it will run our function and return the length of the input. Passthrough vs Strict Evaluation By default Patch will evaluate the callable in :passthrough mode. In passthrough mode if the callable raises either BadArityError or FunctionClauseError then the original function will be called. In :strict mode these errors will be returned. One of the core design principles underlying Patch is that it tries to obey the intent of the test author. Consider the following example. defmodule Example do use GenServer # Snip all the GenServer boilerplate def handle_call ( { :a , argument } , _from , state ) do # Operation A Definition { :reply , result , state } end def handle_call ( { :b , argument } , _from , state ) do # Operation B Definition { :reply , result , state } end end When a test author writes the following test code, how should Patch interpret it? patch ( Example , :handle_call fn { :a , _argument } , _from , state -&gt; { :reply , :ok , state } end ) There are two possible interpretations, either the test author wants to patch the callback responsible for handling messages shaped like {:a, argument} or the test author intends to replace all handle_call callback with one only capable of handling {:a, argument} . Patch already has an opinion on which of these to prefer, we can see it in how Patch handles patching out one function in a module. The assumption is that the test author will apply the minimum patch possible, so patching a single function in a module leaves all the other functions in the module as they were. Applying a similar &quot;default passthrough&quot; behavior to this situation it leads us to one conclusion, the test author probably just wants to replace the functionality handling {:a, argument} and should leave the other callbacks alone. There are always exceptions to the default rule, and Patch wants to make it possible to express the other idea. The test author can inform Patch of their intention by using the :strict evaluation mode. patch ( Example , :handle_call , callable ( fn { :a , _argument } , _from , state -&gt; { :reply , :ok , state } end , evaluate : :strict ) ) Stacked Callables Callables stack as they are defined in the test. Every time a function is patched with a callable, that callable is pushed to the top of the stack. When the patched function is called, the stack is walked from the top to bottom to find a callable that can handle it. There are two problems that are nicely solved by Stacked Callables. Patching functions with multiple arities and making pattern matching in patching composable. Stacking and Multiple Arities The first problem that Stacked Callables solves is patching functions with multiple arities. Consider this example module. defmodule Example do def example ( a ) do { :original , a } end def example ( a , b , c ) do { :original , a , b , c } end end This module defines two functions example/1 and example/3 . How can we patch both functions? Our first attempt might look something like this: Note: this code is invalid and won't compile patch ( Example , :example , fn a -&gt; { :patched , a } a , b , c -&gt; { :patched , a , b , c } end ) This code is illegal in Elixir, the compiler will throw a CompileError and explain that you &quot;cannot mix clauses with different arities in anonymous functions.&quot; The first solution for this was introduced in v0.6.0 and took the form of a &quot;dispatch mode.&quot; By default Patch will use the :apply mode, which calls the function with the same arity as the patched function was called. There is an alternative &quot;dispatch mode&quot; called :list which will pass all the arguments as a single argument, a list of the arguments. This code will work, but is unwieldy patch ( Example , :example , callable ( fn [ a ] -&gt; { :patched , a } [ a , b , c ] -&gt; { :patched , a , b , c } end , dispatch : :list ) This solution made it possible to handle multiple arities, but it is pretty clunky. With stacked callables we can actually just define two separate callables, one for arity 1, and one for arity 3. This code works and is easy to read and write patch ( Example , :example , fn a -&gt; { :patched , a } end ) patch ( Example , :example , fn a , b , c -&gt; { :patched , a , b , c } end ) To understand how this works, let's look at how a call to example/1 and a call to example/3 work. The first thing we have to understand is what the Callable Stack looks like, so let's diagram it. # Top of Stack (latest defined callable) [ fn a , b , c -&gt; { :patched , a , b , c } end , fn a -&gt; { :patched , a } end ] # Bottom of Stack (earliest defined callable) Patch will run each function until one returns a valid value, the first function to respond with a return value will cause evaluation to complete. When Example.example(1) is evaluated it will try the first function. This function has a different arity so it will raise BadArityError , this is one of the two errors that engages passthrough behavior. Since the first entry in the stack resulted in a logical passthrough Patch will try the next entry. The next entry has the right arity and results in {:patched, 1} being returned. When Example.example(1, 2, 3) is evaluated, it's a bit simpler. The first function is tried and it matches in arity so it immediately returns {:patched, 1, 2, 3} and evaluation is completed. Stacking and Matching Another problem that Stacked Callables helps solve is composability when patching with pattern matching. Consider the following example module. defmodule Example do def handle ( :a ) do { :original , :a } end def handle ( :b ) do { :original , :b } end def handle ( :c ) do { :original , :c } end end If a test author wanted to provide patched behavior for :a and :b they can do so like this. patch ( Example , :handle , fn :a -&gt; { :patched , :a } :b -&gt; { :patched , :b } end ) Which is a very convenient use of built-in Elixir feature, namely that anonymous functions can have multiple clauses. But what if we want to have a common behavior for patching out the handling of :a and the handling of :b . Perhaps in one test we want patch out :a , in another :a and :b , and in a third just :b . Is there any way that we can DRY up this code and make it composable? Stacked Callables make this quite nice because it makes it possible to patch multiple clauses at different times. defmodule ExampleTest do use ExUnit use Patch def patch_a do patch ( Example , :handle , fn :a -&gt; { :patched , a } end ) end def patch_b do patch ( Example , :handle , fn :b -&gt; { :patched , b } end ) end test &quot;that cares about :a&quot; do patch_a ( ) assert Example . handle ( :a ) == { :patched , :a } end test &quot;that cares about :a and :b&quot; do patch_a ( ) patch_b ( ) assert Example . handle ( :a ) == { :patched , :a } assert Example . handle ( :b ) == { :patched , :b } end test &quot;that cares about :b&quot; do patch_b ( ) assert Example . handle ( :b ) == { :patched , :b } end end Besides improving composability, it can also just make test code easier to read by breaking multiple logical patches into multiple calls. Compare patch ( Example , :handle , fn :a -&gt; { :patched , :a } :b -&gt; { :patched , :b } end ) with patch ( Example , :handle , fn :a -&gt; { :patched , :a } end ) patch ( Example , :handle , fn :b -&gt; { :patched , :b } end ) The power of this mechanism becomes readily apparent when applied to something like GenServer patch ( Example , :handle_call , fn { :a , _args } , _from , state -&gt; { :reply , :ok , state } end ) patch ( Example , :handle_call , fn { :b , _args } , _from , state -&gt; { :reply , :ok , state } end ) It is common for a GenServer to have many handle_call, handle_cast, and handle_info callbacks. Being able to define the patches by the pattern makes it easy to patch out a subset of the GenServer's behavior Functions as Scalars If functions are always considered callable, how can we patch a function so that it returns a function literal? This can be accomplished by wrapping the function in a call to scalar/1 to turn it into a scalar. defmodule PatchExample do use ExUnit.Case use Patch test &quot;patch returns a function literal&quot; do patch ( Example , :get_name_normalizer , scalar ( &amp; String . downcase / 1 ) ) normalizer = Example . get_name_normalizer ( ) assert normalizer . ( &quot;Patch&quot; ) == &quot;patch&quot; end end","ref":"02-patching.html#callable-values"},{"type":"extras","title":"Chapter 2: Patching - Other Values","doc":"There are other types of values supported by Patch , see Chapter 3: Mock Values","ref":"02-patching.html#other-values"},{"type":"extras","title":"Chapter 2: Patching - Ergonomics","doc":"patch/3 returns the value that the patch will return which can be useful for later on in the test. Examine this example code for an example defmodule PatchExample do use ExUnit.Case use Patch test &quot;patch returns the patch&quot; do { :ok , expected } = patch ( My.Module , :some_function , { :ok , 123 } ) # ... additional testing code ... assert response . some_function_result == expected end end This allows the test author to combine creating fixture data with patching.","ref":"02-patching.html#ergonomics"},{"type":"extras","title":"Chapter 2: Patching - Asserting / Refuting Calls","doc":"After a patch is applied, all subsequent calls to the module become &quot;Observed Calls&quot; and tests can assert that an expected call has occurred by using the assert_called/1 macro. defmodule PatchExample do use ExUnit.Case use Patch test &quot;asserting calls on a patch&quot; do patch ( String , :upcase , :patched ) assert :patched = String . upcase ( &quot;hello&quot; ) # Assertion passes after patching assert_called String . upcase ( &quot;hello&quot; ) # Assertion passes after call end end assert_called/1 supports full pattern matching and non-hygienic binds. This is similar to how ExUnit's assert_receive/3 and assert_received/2 work. # Wildcards are supported assert_called String . upcase ( _ ) # Pinned variables are supported expected = &quot;hello&quot; assert_called String . upcase ( ^ expected ) # Unpinned variables are supported assert_called String . upcase ( argument ) assert argument == &quot;hello&quot; Tests can also refute that a call has occurred with the refute_called/1 macro. This macro works in much the same way as assert_called/1 and has full pattern support. defmodule PatchExample do use ExUnit.Case use Patch test &quot;refuting calls on a patch&quot; do patch ( String , :upcase , :patched ) assert &quot;h&quot; == String . at ( &quot;hello&quot; , 0 ) refute_called String . upcase ( &quot;hello&quot; ) end end Asserting / Refuting Call Once We can assert that a call has only happened once with the assert_called_once/1 macro. This assertion will only pass if the only one observed call matches. defmodule PatchExample do use ExUnit.Case use Patch test &quot;refuting a patch was called once&quot; do patch ( String , :upcase , :patched ) assert_called_once String . upcase ( &quot;hello&quot; ) # Assertion fails before the function is called. assert :patched == String . upcase ( &quot;hello&quot; ) assert_called_once String . upcase ( &quot;hello&quot; ) # Assertion passes after called once. assert :patched == String . upcase ( &quot;hello&quot; ) assert_called_once String . upcase ( &quot;hello&quot; ) # Assertion fails after second call. end end assert_called_once/1 supports patterns and binds just like assert_called/1 . In the above example the following assertion would behave identically. # Wildcards are supported assert_called_once String . upcase ( _ ) # Pinned variables are supported expected = &quot;hello&quot; assert_called_once String . upcase ( ^ expected ) # Unpinned variables are supported assert_called_once String . upcase ( argument ) assert argument == &quot;hello&quot; Tests can also refute that a call has occurred once with the refute_called_once/1 macro. This macro works in much the same way as assert_called_once/1 and has full pattern support. defmodule PatchExample do use ExUnit.Case use Patch test &quot;refuting calls on a patch&quot; do patch ( String , :upcase , :patched ) refute_called_once String . upcase ( &quot;hello&quot; ) # Assertion passes before the function is called. assert :patched == String . upcase ( &quot;hello&quot; ) refute_called_once String . upcase ( &quot;hello&quot; ) # Assertion fails after called once. assert :patched == String . upcase ( &quot;hello&quot; ) refute_called_once String . upcase ( &quot;hello&quot; ) # Assertion passes after second call. end end Asserting / Refuting Call Counts We can assert that a call has happened some given number of times exactly with the assert_called/2 macro. The second argument is the number of observed call matches there must be to pass. defmodule PatchExample do use ExUnit.Case use Patch test &quot;asserting 3 calls on a patch&quot; do patch ( String , :upcase , :patched ) assert :patched == String . upcase ( &quot;hello&quot; ) assert_called String . upcase ( &quot;hello&quot; ) , 3 # Assertion fails after first call. assert :patched == String . upcase ( &quot;hello&quot; ) assert_called String . upcase ( &quot;hello&quot; ) , 3 # Assertion fails after second call. assert :patched == String . upcase ( &quot;hello&quot; ) assert_called String . upcase ( &quot;hello&quot; ) , 3 # Assertion passes after third call. end end assert_called/2 supports patterns and binds just like assert_called/1 . Since multiple calls might match any binds bind to the latest matching call. In the above example the following assertion would behave identically. # Wildcards are supported assert_called String . upcase ( _ ) , 3 # Pinned variables are supported expected = &quot;hello&quot; assert_called String . upcase ( ^ expected ) , 3 # Unpinned variables are supported assert_called String . upcase ( argument ) , 3 assert argument == &quot;hello&quot; Tests can also refute that a call has happened an exact number of times with the refute_called/2 macro. This macro works in much the same way as assert_called/2 and also has full pattern support. defmodule PatchExample do use ExUnit.Case use Patch test &quot;refuting 3 calls on a patch&quot; do patch ( String , :upcase , :patched ) assert :patched == String . upcase ( &quot;hello&quot; ) refute_called String . upcase ( &quot;hello&quot; ) , 3 # Assertion passes after first call. assert :patched == String . upcase ( &quot;hello&quot; ) refute_called String . upcase ( &quot;hello&quot; ) , 3 # Assertion passes after second call. assert :patched == String . upcase ( &quot;hello&quot; ) refute_called String . upcase ( &quot;hello&quot; ) , 3 # Assertion fails after third call. end end Asserting / Refuting Multiple Arities If a function has multiple arities that may be called based on different conditions the test author may wish to assert or refute that a function has been called at all without regards to the number of arguments passed. This can be accomplished with the assert_any_call/1 and refute_any_call/1 functions. defmodule PatchExample do use ExUnit.Case use Patch test &quot;asserting any call on a patch&quot; do patch ( String , :pad_leading , fn s -&gt; s end ) # This formatting call might provide custom padding characters based on # time of day. (This is an obviously constructed example). TimeOfDaySensitiveFormatter . format ( &quot;Hello World&quot; ) assert_any_call String . pad_leading end end Similarly we can refute any call defmodule PatchExample do use ExUnit.Case use Patch test &quot;refuting any call on a patch&quot; do patch ( String , :pad_leading , fn s -&gt; s end ) assert { :error , :not_a_string } = TimeOfDaySensitiveFormatter . format ( 123 ) refute_any_call String . pad_leading end end Advanced Use Cases The assert_any_call/2 and refute_any_call/2 functions take two arguments the module and the function name as an atom. This allows some more advanced use cases where the module or function isn't known at test authoring time. defmodule PatchExample use ExUnit.Case use Patch test &quot;asserting any call on normalizer&quot; do spy ( Formatter ) normalizer = Formatter . get_normalizer ( ) assert_any_call Fromatter , normalizer # Assertion fails before call Formatter . normalize ( &quot;hello&quot; , with : normalizer ) assert_any_call Fromatter , normalizer # Assertion passes after call end end Similarly we can refute any call defmodule PatchExample use ExUnit.Case use Patch test &quot;refuting any call on normalizer&quot; do spy ( Formatter ) normalizer = Formatter . get_normalizer ( ) refute_any_call Formatter , normalizer # Assertion passes before call Formatter . normalize ( &quot;hello&quot; , with : normalizer ) refute_any_call Formatter , normalizer # Assertion fails after call end end","ref":"02-patching.html#asserting-refuting-calls"},{"type":"extras","title":"Chapter 3: Mock Values","doc":"In Chapter 2: Patching we covered two kinds of mock values, Callables and Scalars. There are 5 other kinds of mock values available for use in a test.","ref":"03-mock-values.html"},{"type":"extras","title":"Chapter 3: Mock Values - Cycle Values","doc":"Cycle Values will endlessly cycle through a list of return values. When a patched function has a Values.Cycle as its mock value, it will provide the first value in the cycle and then move the first value to the end of the cycle on every invocation. Consider a function patched with cycle([1, 2, 3]) via the following code patch ( Example , :example , cycle ( [ 1 , 2 , 3 ] ) ) Invocation Cycle Before Call Return Value Cycle After Call 1 [1, 2, 3] 1 [2, 3, 1] 2 [2, 3, 1] 2 [3, 1, 2] 3 [3, 1, 2] 3 [1, 2, 3] 4 [1, 2, 3] 1 [2, 3, 1] 5 [2, 3, 1] 2 [3, 1, 2] 6 [3, 1, 2] 3 [1, 2, 3] 7 [1, 2, 3] 1 [2, 3, 1] We could continue the above table forever since the cycle will repeat endlessly. Cycles can contain callable/1,2 , raise/1,2 and throw/1 mock values. We could create a patch that raises a RuntimeError every other call. patch ( Example , :example , cycle ( [ :ok , raises ( &quot;broken&quot; ) ] ) ) This can be helpful for testing retry and backoff constructs, a cycle like this is a good simulation of an unreliable network or dependency.","ref":"03-mock-values.html#cycle-values"},{"type":"extras","title":"Chapter 3: Mock Values - Sequence Values","doc":"Sequence values are similar to cycles, but instead of cycling the list is consumed until only one element is remaining. Once the sequence has only a single element remaining, that element will be returned on all subsequent calls. Consider a function patched with sequence([1, 2, 3]) via the following code patch ( Example , :example , sequence ( [ 1 , 2 , 3 ] ) ) Invocation Sequence Before Call Return Value Sequence After Call 1 [1, 2, 3] 1 [2, 3] 2 [2, 3] 2 [3] 3 [3] 3 [3] 4 [3] 3 [3] 5 [3] 3 [3] We could continue the above table forever since the sequence will continue to return the last value endlessly. Sequences can contain callable/1,2 , raise/1,2 and throw/1 mock values. There is one special behavior of sequence, and that's an empty sequence, which always returns the value nil on every invocation. If the test author would like to simulate an exhaustable sequence, one that returns a set number of items and then responds to every other call with nil , they can simply add a nil as the last element in the sequence patch ( Example , :example , sequence ( [ 1 , 2 , 3 , nil ] ) Invocation Sequence Before Call Return Value Sequence After Call 1 [1, 2, 3, nil] 1 [2, 3, nil] 2 [2, 3, nil] 2 [3, nil] 3 [3, nil] 3 [nil] 4 [nil] nil [nil] 5 [nil] nil [nil]","ref":"03-mock-values.html#sequence-values"},{"type":"extras","title":"Chapter 3: Mock Values - Raises Value","doc":"When a function can fail by raising an exception we can use raises/1,2 to have the patched function raise. raise/1 creates a special Values.Callable to be used as a mock value. This callable ignores the arguments passed in and unconditionally raises a RuntimeError with the given message. patch ( Example , :example , raises ( &quot;patched&quot; ) ) assert_raise RuntimeError , &quot;patched&quot; , fn -&gt; Example . example ( ) end raise/2 creates a special Values.Callable to be used as a mock value. This callable ignores the arguments passed in and unconditionally raises the specified exception with the given attributes. patch ( Example , :example , raises ( ArgumentError , message : &quot;patched&quot; ) ) assert_raise ArgumentError , &quot;patched&quot; , fn -&gt; Example . example ( ) end","ref":"03-mock-values.html#raises-value"},{"type":"extras","title":"Chapter 3: Mock Values - Throws Value","doc":"When a function can fail by raising an exception we can use throws/1 to have the patched function throw. throws/1 creates a special Values.Callable to be used as a mock value. This callable ignores the arguments passed in and unconditionally throws the given value. patch ( Example , :example , throws ( :patched ) ) assert catch_throw ( Example . example ( ) ) == :patched","ref":"03-mock-values.html#throws-value"},{"type":"extras","title":"Chapter 4: Spies and Fakes","doc":"In Chapter 2: Patching and Chapter 3: Mock Values we saw how we can patch functions to return particular mock values. There are two common cases for patching that have special helpers.","ref":"04-spies-and-fakes.html"},{"type":"extras","title":"Chapter 4: Spies and Fakes - Spies","doc":"If a test wishes to assert / refute calls that happen to a module without actually changing the behavior of the module it can simply spy/1 the module. Spies behave identically to the original module but all calls are recorded so assert_called/1 , refute_called/1 , assert_any_called/2 , and refute_any_called/2 work as expected. defmodule PatchExample do use ExUnit.Case use Patch def example ( value ) do String . upcase ( value ) end test &quot;spies can see what calls happen without changing functionality&quot; do spy ( String ) assert &quot;HELLO&quot; == example ( &quot;hello&quot; ) assert_called String . upcase ( &quot;hello&quot; ) end end","ref":"04-spies-and-fakes.html#spies"},{"type":"extras","title":"Chapter 4: Spies and Fakes - Fakes","doc":"Sometimes we want to replace one module with another for testing, for example we might want to replace a module that connects to a real datastore with a fake that stores data in memory while providing the same API. The fake/2,3 functions can be used to replace one module with another. The replacement module can be completely stand alone or can utilize the functionality of the replaced module, it will be made available through use of the real/1 function. defmodule HighLatencyDatabase do @latency System . convert_time_unit ( 20 , :second , :microsecond ) def get ( id ) do { elapsed , response } = :timer . tc ( fn -&gt; Patch . real ( Database ) . get ( id ) end ) induce_latency ( elapsed ) response end defp induce_latency ( elapsed ) when elapsed &lt; @latency do time_to_sleep = System . convert_time_unit ( @latency - elapsed , :microsecond , :millisecond ) Process . sleep ( time_to_sleep ) end defp induce_latency ( _ ) , do : :ok end This fake module uses the real module to actually get the record from the database and then makes sure that a minimum amount of latency, in this case 20 seconds, is introduced before returning the result. To swap out our real Database with our fake HighLatencyDatabase in a test we can now do the following defmodule PatchExample do use ExUnit.Case use Patch def example ( value ) do String . upcase ( value ) end test &quot;API raises TimeoutError when database is experiencing high latency&quot; do fake ( Database , HighLatencyDatabase ) assert_raises TimeoutError , fn -&gt; API . get ( :user , 1 ) end end end","ref":"04-spies-and-fakes.html#fakes"},{"type":"extras","title":"Chapter 5: Processes","doc":"Elixir code frequently runs many processes and a test author often wants to assert about the flow of messages between processes. Patch provides some utilities that make listening to the messages between processes easy.","ref":"05-processes.html"},{"type":"extras","title":"Chapter 5: Processes - Listeners","doc":"Listeners are processes that sit between the sender process and the target process. The listener process will send a copy of every message to the test process so it can use ExUnit's built in assert_receive , assert_received , refute_receive , and refute_received functions. Listeners are especially useful when working with named processes since they will automatically unregister the named process and take its place. For anonymous processes the inject/3 function is provided to assist in injecting listeners into other processes or the listener can be used in place of the target process when starting consumer processes. Listeners are started with the listen/3 function and each have a tag so that the test process can differentiate which listener has delivered which message. defmodule PatchExample do use ExUnit.Case use Patch test &quot;sharded read replication&quot; do listen ( :shard_a_leader , ShardALeader ) listen ( :shard_a_replica_1 , ShardAReplica1 ) listen ( :shard_a_replica_2 , ShardAReplica2 ) listen ( :shard_b_leader , ShardBLeader ) listen ( :shard_b_replica_1 , ShardBReplica1 ) listen ( :shard_b_replica_2 , ShardBReplica2 ) send ( ShardALeader , { :write , :some_value } ) # Assert the leader gets the message assert_receive { :shard_a_leader , { :write , :some_value } } # Assert that the replicas for Shard A get the message too assert_receive { :shard_a_replica_1 , { :write , :some_value } } assert_receive { :shard_a_replica_2 , { :write , :some_value } } # Assert that Shard A does not try to replicate to Shard B refute_receive { :shard_b_leader , { :write , :some_value } } refute_receive { :shard_b_replica_1 , { :write , :some_value } } refute_receive { :shard_b_replica_2 , { :write , :some_value } } end end GenServer Support Listeners have special support for GenServers. By default a listener will provide the test process with all calls, replies, casts, and messages. Given a listener with the tag :tag the messages from a GenServer are formatted as follows. Client Code Message to Test Process GenServer.call(pid, :message) {:tag, {GenServer, :call, :message, from}} # if capture_replies = true {:tag, {GenServer, :reply, result, from}} GenServer.cast(pid, :message) {:tag, {GenServer, :cast, :message}} During a GenServer.call/3 the listener sits between the client and the server and reports back information to the test process. .------------. .------. .--------. .------. |Test Process| |client| |listener| |server| '------------' '------' '--------' '------' | | GenServer.call(message)| | | | -----------------------&gt; | | | | | | {GenServer, :call, message, from} | | | &lt;- - - - - - - - - - - - - - - - - - - - - - | | | | | | | | GenServer.call(message)| | | | -----------------------&gt; | | | | | | | reply | | | | &lt;----------------------- | | | | | {GenServer, :reply, reply, from} | | | &lt;- - - - - - - - - - - - - - - - - - - - - - | | | | | | | reply | | | | &lt;----------------------- | .------------. .------. .--------. .------. |Test Process| |client| |listener| |server| '------------' '------' '--------' '------'` GenServer.call/3 allows the client to set a timeout, an amount of time to wait for the server to response. The listener does not know how long the original client will wait for a timeout, the test author can provide a :timeout option when spawning the listener to control how long the listener will wait for its GenServer.call/3 . By default the listener will wait 5000ms for each call, the default for GenServer.call/2 . Since assert_receive/3 supports binding, we can use the from to match a call and a reply. defmodule PatchExample do use ExUnit.Case use Patch test &quot;matching calls and replies&quot; do Counter . start_link ( 0 , name : Counter ) listen ( :counter , Counter ) assert Counter . increment ( ) == 1 assert_receive { :counter , { GenServer , :call , :increment , from } } # Bind `from` assert_receive { :counter , { GenServer , :reply , 1 , ^ from } } # Match the pinned `from` end end If the test doesn't require the listener to capture replies to GenServer.call then the :capture_replies option can be set to false. When this option is false the listener will simply forward the call onto the server. Refer to the following diagram for details on how this works. .------------. .------. .--------. .------. |Test Process| |client| |listener| |server| '------------' '------' '--------' '------' | | GenServer.call(message)| | | | -----------------------&gt; | | | | | | {GenServer, :call, message, from} | | | &lt;- - - - - - - - - - - - - - - - - - - - - - | | | | | | | | send(:&quot;$gen_call&quot;, from, message)| | | | ---------------------------------&gt; | | | | | | | reply | | | &lt;---------------------------------------------------------- .------------. .------. .--------. .------. |Test Process| |client| |listener| |server| '------------' '------' '--------' '------' Target Monitoring Listeners will automatically monitor the target process they are listening to. If the target process goes :DOWN the listener will deliver a tagged {:DOWN, reason} message to the test process and then exit.","ref":"05-processes.html#listeners"},{"type":"extras","title":"Chapter 5: Processes - Injecting Listeners","doc":"listen/3 works well for named processes when callers are using the name to send messages to the target process. What should we do when callers are sending to a pid instead of a name? This is where the inject/4 function can be used. inject/4 will extract a pid out of a GenServer's state, wrap it with a listener and then replace the pid in the GenServer's state with the listener pid. inject/4 will also work with keys in the GenServer's state that are nil , it will generate a targetless listener and replace the nil with that listner's pid. This latter behavior is nice when working with a process that will spawn another process and keep track of its pid in state if the spawning behavior is outside the scope of your test. Here's a simple example, we will have 2 modules, Target and Caller . defmodule Target do use GenServer ## Client def start_link ( multiplier ) do GenServer . start_link ( __MODULE__ , multiplier ) end def work ( pid , argument ) do GenServer . call ( pid , { :work , argument } ) end ## Server def init ( multiplier ) do { :ok , multiplier } end def handle_call ( { :work , argument } , _from , multiplier ) do { :reply , argument * multiplier , multiplier } end end Our Target module isn't very interesting, it can do some work/1 where the caller sends it a number and it multiplies it by the multiplier it was started with and returns it. Next let's look at our Caller defmodule Caller do use GenServer defstruct [ :bonus , :target_pid ] ## Client def start_link ( bonus , multiplier ) do GenServer . start_link ( __MODULE__ , { bonus , multiplier } ) end def calculate ( pid , argument ) do GenServer . call ( pid , { :calculate , argument } ) end ## Server def init ( { bonus , multiplier } ) do { :ok , target_pid } = Target . start_link ( multiplier ) { :ok , % __MODULE__ { bonus : bonus , target_pid : target_pid } } end def handle_call ( { :calculate , argument } , _from , % __MODULE__ { } = state ) do multiplied = Target . work ( state . target_pid , argument ) { :reply , multiplied + state . bonus , state } end end Our Caller takes two values, a bonus and a multiplier . It spawns a new Target process with the multiplier and stores the target_pid in its state. The Caller process will send a message to the target_pid it has stored in its state. Here's how we can use inject/4 to listen to the messages between the Caller process and the Target process. defmodule PatchExample do use ExUnit.Case use Patch test &quot;listen to messages to Target Process&quot; do bonus = 5 multiplier = 10 { :ok , caller_pid } = Caller . start_link ( bonus , multiplier ) inject ( :target , caller_pid , [ :target_pid ] ) assert Caller . calculate ( caller_pid , 7 ) == 75 # (7 * 10) + 5 assert_receive { :target , { GenServer , :call , { :work , 7 } , from } } assert_receive { :target , { GenServer , :reply , 70 , ^ from } } end end inject/4 accepts the same options as listen/3 and returns the {:ok, listener_pid} after successfully injecting the listener. Targetless Listeners Listeners can also be used in place of a real process. Targetless listeners are nearly identical to listeners with one key exception, GenServer.call/3 . A Targetless Listener will happily forward a normal message sent with send/3 or a GenServer.cast/2 message to nowhere, but GenServer.call/3 expects a reply and there isn't one coming when the Listener has no Target. To make this failure mode more apparent, since it likely means that the author didn't intend to set up a Targetless Listener, attempting to GenServer.call/3 at a Targetless Listener will have the following effects. The listener will forward {tag, {GenServer, :call, message, from}} to the test process The listener will forward {tag, {:EXIT, :no_listener_target}} to the test process The listener will crash with the reason :no_listener_target","ref":"05-processes.html#injecting-listeners"},{"type":"extras","title":"Chapter 5: Processes - Replacing State","doc":"When working with processes in test code it is sometimes necessary to change the state of a running GenServer. Common use cases for injecting state into a GenServer are to set up some fixture data, update a configuration value, or replacing pids like in the previous section. replace/3 is a helper that handles some common issues when updating state. defmodule PatchExample do use ExUnit.Case use Patch test &quot;state can be replaced&quot; do { :ok , pid } = Target . start_link ( :initial_value ) assert :initial_value == Target . get_value ( pid ) replace ( pid , [ :value ] , :updated_value ) assert :updated_value == Target . get_value ( pid ) end end replace/3 accepts a GenServer.server a list of keys like one would use for put_in/3 and then a value to inject into the processes state. Unlike put_in/3 , replace/3 will work with Structs that do not implement the Access behaviour. It does not support the Access functions though, just a list of keys.","ref":"05-processes.html#replacing-state"}]